#!/usr/bin/perl -w
#
# Configure script to configure DarkSUSY.
# NOTE. Run this script before compiling DarkSUSY.
#
# Author: Joakim Edsjo, edsjo@physto.se
# Date: August 30,2000

$mufile="src/mu/dsmudir.h";
$hafile="src/ha/dshadir.h";

$dsroot=shift;
$dsroot="$dsroot/" unless $dsroot=~ #/$/;

# Take care of muon yield file.
open(IN,"$mufile") || die "Can't open $mufile for reading.\n";
$line=<IN>;
close(IN);

$newline=$line;
$newline =~ s#'.*'#'$dsroot/lib/'#;
if ($newline ne $line) {
    open(OUT,">$mufile") || 
      die "Can't open $mufile for writing\n";
    print OUT $newline;
    close(OUT);
    print "$mufile updated.\n";
} else {
    print "$mufile is up-to-date.\n";
}

# Take care of halo yield file.
open(IN,"$hafile") || die "Can't open $hafile for reading.\n";
$line=<IN>;
close(IN);

$newline=$line;
$newline =~ s#'.*'#'$dsroot/lib/'#;
if ($newline ne $line) {
    open(OUT,">$hafile") || 
      die "Can't open $hafile for writing\n";
    print OUT $newline;
    close(OUT);
    print "$hafile updated.\n";
} else {
    print "$hafile is up-to-date.\n";
}
