      subroutine dsacbnd(excl)
      implicit none
      include 'dsaccom.h'
      integer excl
      if (aclabel.eq.'pdg2000'.or.aclabel.eq.'default') then
         call dsacbnd3(excl)
      else if (aclabel.eq.'mar2000') then
         call dsacbnd2(excl)
      else if (aclabel.eq.'pdg1999') then
         call dsacbnd1(excl)
      else
         write(*,*) 'Error in dsacbnd: invalid option: ',aclabel
         stop
      endif
      return
      end
      subroutine dsacbnd1(excl)
c_______________________________________________________________________
c  check if accelerator data exclude the present point.
c  output:
c    excl - code of the reason for exclusion (integer); 0 if allowed
c  common:
c    'dssusy.h' - file with susy common blocks
c  author: paolo gondolo 1994-1999
c  history:
c     940407 first version paolo gondolo
c     950323 update paolo gondolo
c     971200 partial update joakim edsjo
c     980428 update joakim edsjo
c     990719 update paolo gondolo
c=======================================================================
      implicit none
      include 'dssusy.h'
      integer i,j,excl
      logical excluded
      real*8 gzinv,temp,mi,mj,ei,ej,p2,mz,mz2,dsabsq,bsg,
     &  beta,y,mh2lim
      complex*16 gzij
      excl=0

c----------------------------------------------bounds from b -> s gamma
      call dsbsgamma(bsg,bsgqcd)
      if (bsg.lt.1.00d-4.or.bsg.gt.4.0d-4) then
         excl=ibset(excl,7)
      endif

c------------------------------------------lower bound on chargino mass
c...je update 98-04-28 from aleph, talk by j. carr, march 31, 1998
c...http://alephwww.cern.ch/alpub/seminar/carrlepc98/index.html
      if (abs(mass(kcha(2))).lt.91.0d0.and.
     &  abs(mass(kn(1))-mass(kcha(2))).gt.4.0d0)
     &  excl=ibset(excl,0)
c        pdg 99 acciarri 96 l3 plb377,289
      if (abs(mass(kcha(2))).lt.64.d0 .and.
     &     abs(mass(kn(kln))).lt.43.0d0 .and.
     &     abs(mass(kcha(2))).lt.abs(mass(kn(2))))
     &     excl=ibset(excl,0)
c        pdg 94 p 1801 iii decamp92 aleph
      if (abs(mass(kcha(2))).lt.47.d0 .and.
     &     abs(mass(kn(kln))).lt.41.0d0)
     &     excl=ibset(excl,0)
c        pdg 94 p 1801 iv hidaka91 cdf
      if (abs(mass(kcha(1))).lt.99.0d0) excl=ibset(excl,0)

c--------------------------------------------lower bound on gluino mass
c        pdg 94 p 1803 i abe92 cdf was 218 (90%cl)
c        pdg 99 abachi95 d0 prl75,618 is 212 (95%cl)
      excluded=.false.
      do i=1,6
        excluded = excluded .or. (mass(ksqu(i)).lt.mass(kgluin)) .or.
     &        (mass(ksqd(i)).lt.mass(kgluin))
      enddo
      if (excluded .and. mass(kgluin).lt.212.0d0) excl=ibset(excl,1)
c        pdg 94 p 1803 ii abe92 cdf was 100
c        pdg 99 abe97 cdf prd56, r1357 is 173-10 (see note)
      if (mass(kgluin).lt.163.0d0) excl=ibset(excl,1)

c------------------------------------------lower bound on squark masses
c        pdg 94 p 1802 i abe92 cdf is 90 with mgluino<410
      excluded=.false.
      do i=1,6
        excluded = excluded .or. (mass(ksqu(i)).lt.90.0d0) .or.
     &        (mass(ksqd(i)).lt.90.0d0)
      enddo
      if (excluded .and. mass(kgluin).lt.410.0d0) excl=ibset(excl,2)
c        pdg 94 abachi95 d0 prl75,618 is 176 with mgluino<300
      excluded=.false.
      do i=1,6
        excluded = excluded .or. (mass(ksqu(i)).lt.176.0d0) .or.
     &        (mass(ksqd(i)).lt.176.0d0)
      enddo
      if (excluded .and. mass(kgluin).lt.300.0d0) excl=ibset(excl,2)
c        pdg 94 p 1802 iii abe92 cdf was 180
c        pdg 99 abe96 cdf prl76,2006 is 224
      excluded=.false.
      do i=1,6
        excluded = excluded .or.
     &    (mass(ksqu(i)).lt.224.d0 .and. mass(ksqu(i)).gt.mass(kgluin))
     &    .or.
     &    (mass(ksqu(i)).lt.224.d0 .and. mass(ksqd(i)).gt.mass(kgluin))
      enddo
      if (excluded) excl=ibset(excl,2)

c---------------------------------lower bound on charged slepton masses
c        selectron pdg 94 p 1801 ii decamp92 aleph was 45 with 41
c                  pdg 99 barate98 aleph plb433,176 is 78 with 73
      if (mass(ksl(1)).lt.78.0d0 .and. abs(mass(kn(kln))).lt.73.d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(2)).lt.78.0d0 .and. abs(mass(kn(kln))).lt.73.d0)
     &     excl=ibset(excl,3)
c        smuon pdg 94 p 1802 ii decamp92 aleph was 45 with 41
c              pdg 99 barate98 aleph plb433,176 is 71 with 66
      if (mass(ksl(3)).lt.71.0d0 .and. abs(mass(kn(kln))).lt.66.d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(4)).lt.71.0d0 .and. abs(mass(kn(kln))).lt.66.d0)
     &     excl=ibset(excl,3)
c        stau pdg 94 p 1802 ii decamp92 aleph was 45 with 38
c             pdg 99 barate98 aleph plb433,176 is 65 with 55
      if (mass(ksl(5)).lt.65.0d0 .and. abs(mass(kn(kln))).lt.55.d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(6)).lt.65.0d0 .and. abs(mass(kn(kln))).lt.55.d0)
     &     excl=ibset(excl,3)

c---------------------------------------lower bound on sneutrino masses
c        pdg 94 p 1801 ii adriani93 l3 was 37.1
c        pdg 99 their very own limit 44.4
      if (mass(ksnu(1)).lt.44.4)
     &     excl=ibset(excl,3)
      if (mass(ksnu(2)).lt.44.4)
     &     excl=ibset(excl,3)
      if (mass(ksnu(3)).lt.44.4)
     &     excl=ibset(excl,3)

c-------------------------------------lower bounds on neutralino masses
c     assumes neutralinos are ordered by increasing mass
c        pdg 94 p 1799 i decamp92 phys rep 216, 253 aleph
c        pdg 99 acciarri95 l3 plb350,109
      if (abs(mass(kn(1))).lt.23.0d0 .and.
     &     tanbe.gt.3.d0) excl=ibset(excl,6)
      if (abs(mass(kn(1))).lt.20.0d0 .and.
     &     tanbe.gt.2.d0) excl=ibset(excl,6)
c        pdg 99 buskulic96 zphys c72,549 aleph
      if ( (abs(mass(kn(1))).lt.12.8.and.mass(ksnu(1)).gt.200.d0).or.
     &     (abs(mass(kn(1))).lt.12.8.and.mass(ksnu(2)).gt.200.d0).or.
     &     (abs(mass(kn(1))).lt.12.8.and.mass(ksnu(3)).gt.200.d0) )
     &     excl=ibset(excl,6)
c        pdg 99 acciarri98 l3 epj c4,207
      if (abs(mass(kn(1))).lt.10.9d0) excl=ibset(excl,6)
c        pdg 99 abbiendi99 opal epj c8,255
      if (abs(mass(kn(2))).lt.44.0d0) excl=ibset(excl,6)
c        pdg 99 abbiendi99 opal epj c8,255
      if (abs(mass(kn(3))).lt.102.d0) excl=ibset(excl,6)
c        pdg 99 acciarri95 l3 plb350,109
      if (abs(mass(kn(4))).lt.127.0d0) excl=ibset(excl,6)

c------------------------------------------------bounds on higgs masses

c      pdg 99 abbiendi99 opal epj c7,407
      if (mass(khc).lt.59.5d0) excl=ibset(excl,5)

c...gao, gay aleph 99-053 (conf 99-029) = hep99 tampere
c...http://alephwww.cern.ch/alpub
      beta=atan(tanbe)
      y=(sin(beta-alpha))**2
      mh2lim=82.5d0+(93.d0-82.5d0)*y
      if (mass(kh2).lt.mh2lim) excl=ibset(excl,5)

c-----------------------------------------bound from gamma_z(invisible)
      mz = mass(kz)
      mz2 = mz*mz
      ! 3 neutrinos
      gzinv = (g2weak/2/costhw)**2 * mz/(24.d0*pi)
      ! 3 sneutrinos
      do i=1,3
         temp = 1.d0-4.d0*mass(ksnu(i))**2/mz2
         if (temp.gt.0.d0) then
            temp = temp**(1.5d0) *
     &           (g2weak/2/costhw)**2 * mz/(48.d0*pi)
            gzinv = gzinv + temp
         endif
      enddo
      ! neutralinos
c...pg fixed june 30, 2000
      do i=1,4
         mi = abs(mass(kn(i)))
         do j=i,4
            mj = abs(mass(kn(j)))
            p2 = (mz2-(mi+mj)**2)*(mz2-(mi-mj)**2)/(4*mz2)
            ei = (mz2-mj**2+mi**2)/(2*mz)
            ej = (mz2-mi**2+mj**2)/(2*mz)
            if (p2.gt.0.d0.and.ei.gt.0.0d0.and.ej.gt.0.0d0) then
               gzij = g2weak/(2.d0*costhw)*
     &              (conjg(neunmx(i,3))*neunmx(j,3)-
     &               conjg(neunmx(i,4))*neunmx(j,4))
               temp=sqrt(p2)/(2.d0*pi*mz2) * (
     &              dsabsq(gzij) * (ei*ej+p2/3.0d0)-
     &              dreal(gzij**2)*mi*mj)
               if (i.eq.j) temp=0.5d0*temp
               gzinv = gzinv + temp
            endif
         enddo
      enddo
c        pdg 94 p 1358 (498.2+4.2)
      if (gzinv.gt.0.5024d0) excl=ibset(excl,4)

c   reason for exclusion
 1000 continue
      if (prtlevel.ge.1) call dswexcl(6,excl)
      return

      end

      subroutine dsacbnd2(excl)
c_______________________________________________________________________
c  check if accelerator data exclude the present point.
c  output:
c    excl - code of the reason for exclusion (integer); 0 if allowed
c    if not allowed, the reasons are coded as follows
c      dsbit set   dec.   oct.   reason
c      -------   ----   ----   ------
c            0      1      1   chargino mass
c            1      2      2   gluino mass
c            2      4      4   squark mass
c            3      8     10   slepton mass
c            4     16     20   invisible z width
c            5     32     40   higgs mass
c            6     64    100   neutralino mass
c            7    128    200   b -> s gamma
c            8    256    400   rho parameter
c  common:
c    'dssusy.h' - file with susy common blocks
c  author: paolo gondolo 1994-1999
c  history:
c     940407 first version paolo gondolo
c     950323 update paolo gondolo
c     971200 partial update joakim edsjo
c     980428 update joakim edsjo
c     990719 update paolo gondolo
c     000310 update piero ullio
c     000424 added delrho joakim edsjo
c=======================================================================
      implicit none
      include 'dssusy.h'
      integer i,j,excl
      logical excluded
      real*8 gzinv,temp,mi,mj,ei,ej,p2,mz,mz2,dsabsq,bsg,
     &  beta,y,mh2lim
      complex*16 gzij
      real*8 diffneucha,absmacha,absmachalim,arrmh2(25),
     & arrsin2ba(25),arrmh2cd(13),arrtanbe(13),lgtgbe,ylim
      integer iiikkk

      data (arrmh2(i),i=1,25)/
     & 0.914500d+02,0.924500d+02,0.936000d+02,0.944500d+02,
     & 0.955000d+02,0.960000d+02,0.979000d+02,0.990500d+02,
     & 0.100750d+03,0.101050d+03,0.102050d+03,0.102800d+03,
     & 0.103300d+03,0.103900d+02,0.104350d+03,0.105100d+03,
     & 0.105800d+03,0.106250d+03,0.106700d+03,0.106850d+03,
     & 0.107000d+03,0.107100d+03,0.107350d+03,0.107450d+03,
     & 0.107700d+03/

      data (arrsin2ba(i),i=1,25)/
     & 0.000d0,0.050d0,0.150d0,0.200d0,0.213d0,0.200d0,0.187d0,
     & 0.187d0,0.200d0,0.213d0,0.250d0,0.300d0,0.350d0,0.400d0,
     & 0.450d0,0.500d0,0.550d0,0.600d0,0.650d0,0.700d0,0.750d0,
     & 0.800d0,0.850d0,0.900d0,1.000d0/

      data (arrtanbe(i),i=1,13)/46.d0,48.d0,49.d0,50.d0,52.d0,53.d0
     & ,55.d0,55.8d0,56.d0,57.d0,58.d0,59.d0,60.d0/

      data (arrmh2cd(i),i=1,13)/90.d0,92.d0,94.d0,95.d0,96.d0,98.d0
     & ,100.d0,102.d0,104.d0,106.d0,108.d0,110.d0,112.d0/

      excl=0

c----------------------------------------------bounds from b -> s gamma
      call dsbsgamma(bsg,bsgqcd)
      if (bsg.lt.1.00d-4.or.bsg.gt.4.0d-4) then
         excl=ibset(excl,7)
      endif

c------------------------------------------lower bound on chargino mass
c...pu update 99-12-22 from l3 talk at lepc meeting in november 1999
c...http://l3www.cern.ch/analysis/latestresults.html
      diffneucha=abs(mass(kn(1))-mass(kcha(2)))
      absmacha=abs(mass(kcha(2)))
      if (absmacha.lt.85.9d0) excl=ibset(excl,0)
      if (absmacha.lt.94.2d0.and.diffneucha.le.0.2d-1)
     &  excl=ibset(excl,0)
      if (absmacha.lt.94.2d0.and.diffneucha.gt.10.d0)
     &  excl=ibset(excl,0)
      if (absmacha.lt.94.2d0.and.
     &  diffneucha.gt.4.2d0.and.diffneucha.le.10.d0) then
        absmachalim=92.3d0+(94.2d0-92.3d0)*(diffneucha-4.2d0)
     &   /(10.d0-4.2d0)
        if(absmacha.lt.absmachalim) excl=ibset(excl,0)
      endif
      if (absmacha.lt.92.3d0.and.
     &  diffneucha.gt.3.5d0.and.diffneucha.le.4.2d0) then
        absmachalim=85.9d0+(92.3d0-85.9d0)*(diffneucha-3.5d0)
     &   /(4.2d0-3.5d0)
        if(absmacha.lt.absmachalim) excl=ibset(excl,0)
      endif
c        pdg 94 p 1801 iv hidaka91 cdf
      if (abs(mass(kcha(1))).lt.99.0d0) excl=ibset(excl,0)

c--------------------------------------------lower bound on gluino mass
c...pu update 00-03-10   pdg 2000 edition update  http://pdg.lbl.gov
      if (mass(kgluin).lt.190.0d0) excl=ibset(excl,1)
      excluded=.false.
      do i=1,6
        excluded = excluded .or. (mass(ksqu(i)).lt.mass(kgluin)) .or.
     &        (mass(ksqd(i)).lt.mass(kgluin))
      enddo
      if (excluded .and. mass(kgluin).lt.260.0d0) excl=ibset(excl,1)

c------------------------------------------lower bound on squark masses
c        pdg 94 p 1802 i abe92 cdf is 90 with mgluino<410
      excluded=.false.
      do i=1,6
        excluded = excluded .or. (mass(ksqu(i)).lt.90.0d0) .or.
     &        (mass(ksqd(i)).lt.90.0d0)
      enddo
      if (excluded .and. mass(kgluin).lt.410.0d0) excl=ibset(excl,2)
c        pdg 94 abachi95 d0 prl75,618 is 176 with mgluino<300
      excluded=.false.
      do i=1,6
        excluded = excluded .or. (mass(ksqu(i)).lt.176.0d0) .or.
     &        (mass(ksqd(i)).lt.176.0d0)
      enddo
      if (excluded .and. mass(kgluin).lt.300.0d0) excl=ibset(excl,2)
c        pdg 94 p 1802 iii abe92 cdf was 180
c        pdg 99 abe96 cdf prl76,2006 is 224
      excluded=.false.
      do i=1,6
        excluded = excluded .or.
     &    (mass(ksqu(i)).lt.224.d0 .and. mass(ksqu(i)).gt.mass(kgluin))
     &    .or.
     &    (mass(ksqu(i)).lt.224.d0 .and. mass(ksqd(i)).gt.mass(kgluin))
      enddo
      if (excluded) excl=ibset(excl,2)

c---------------------------------lower bound on charged slepton masses
c        selectron pdg 94 p 1801 ii decamp92 aleph was 45 with 41
c                  pdg 99 barate98 aleph plb433,176 is 78 with 73
      if (mass(ksl(1)).lt.78.0d0 .and. abs(mass(kn(kln))).lt.73.d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(2)).lt.78.0d0 .and. abs(mass(kn(kln))).lt.73.d0)
     &     excl=ibset(excl,3)
c        smuon pdg 94 p 1802 ii decamp92 aleph was 45 with 41
c              pdg 99 barate98 aleph plb433,176 is 71 with 66
      if (mass(ksl(3)).lt.71.0d0 .and. abs(mass(kn(kln))).lt.66.d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(4)).lt.71.0d0 .and. abs(mass(kn(kln))).lt.66.d0)
     &     excl=ibset(excl,3)
c        stau pdg 94 p 1802 ii decamp92 aleph was 45 with 38
c             pdg 99 barate98 aleph plb433,176 is 65 with 55
      if (mass(ksl(5)).lt.65.0d0 .and. abs(mass(kn(kln))).lt.55.d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(6)).lt.65.0d0 .and. abs(mass(kn(kln))).lt.55.d0)
     &     excl=ibset(excl,3)

c---------------------------------------lower bound on sneutrino masses
c        pdg 94 p 1801 ii adriani93 l3 was 37.1
c        pdg 99 their very own limit 44.4
c...pu update 00-03-10   pdg 2000 edition update  http://pdg.lbl.gov
      if (mass(ksnu(1)).lt.43.d0) excl=ibset(excl,3)
      if (mass(ksnu(2)).lt.43.d0) excl=ibset(excl,3)
      if (mass(ksnu(3)).lt.43.d0) excl=ibset(excl,3)

c-------------------------------------lower bounds on neutralino masses
c     assumes neutralinos are ordered by increasing mass
c...pu update 00-03-10 limit implemented from cern-ep/99-123
c...g. abbiendi et al. (opal collab.) europ. phys. j. c (2000) accepted
c...http://www.cern.ch/opal/pubs/paper/html/pr291.html
c do we want to implement the limits as a function of tan(beta)???
      if (abs(mass(kn(1))).lt.31.6d0) excl=ibset(excl,6)
      if (abs(mass(kn(2))).lt.55.9d0.and.
     &    abs(abs(mass(kn(2)))-abs(mass(kn(1)))).gt.10.d0)
     &    excl=ibset(excl,6)
      if (abs(mass(kn(3))).lt.106.0d0.and.
     &    abs(abs(mass(kn(2)))-abs(mass(kn(1)))).gt.10.d0)
     &    excl=ibset(excl,6)


c        pdg 94 p 1799 i decamp92 phys rep 216, 253 aleph
c        pdg 99 acciarri95 l3 plb350,109
c      if (abs(mass(kn(1))).lt.23.0d0 .and.
c     &     tanbe.gt.3.d0) excl=ibset(excl,6)
c      if (abs(mass(kn(1))).lt.20.0d0 .and.
c     &     tanbe.gt.2.d0) excl=ibset(excl,6)
c        pdg 99 buskulic96 zphys c72,549 aleph
c      if ( (abs(mass(kn(1))).lt.12.8.and.mass(ksnu(1)).gt.200.d0).or.
c     &     (abs(mass(kn(1))).lt.12.8.and.mass(ksnu(2)).gt.200.d0).or.
c     &     (abs(mass(kn(1))).lt.12.8.and.mass(ksnu(3)).gt.200.d0) )
c     &     excl=ibset(excl,6)
c        pdg 99 acciarri98 l3 epj c4,207
c      if (abs(mass(kn(1))).lt.10.9d0) excl=ibset(excl,6)

c        pdg 99 abbiendi99 opal epj c8,255
      if (abs(mass(kn(2))).lt.44.0d0) excl=ibset(excl,6)
c        pdg 99 abbiendi99 opal epj c8,255
      if (abs(mass(kn(3))).lt.102.d0) excl=ibset(excl,6)
c        pdg 99 acciarri95 l3 plb350,109
      if (abs(mass(kn(4))).lt.127.0d0) excl=ibset(excl,6)

c------------------------------------------------bounds on higgs masses
c h3:
c     approx lep  from phys. rep. 216(1992)253, p. 296
c     je correction 97-02-21
      lgtgbe = log10(tanbe)
      if (mass(kh3).lt.45.and.
     &     lgtgbe.gt.(5.5/29.+sqrt(15./1038.))) then
         excl=ibset(excl,5)
      else if (mass(kh3).lt.(30.0+lgtgbe*29.*5.).and.
     &     lgtgbe.lt.(5.5/29.-sqrt(25./1038.))) then
         excl=ibset(excl,5)
      else if (mass(kh3).lt.(60.-1038.*(lgtgbe-5.5/29.)**2).and.
     &     lgtgbe.le.(5.5/29.+sqrt(15./1038.)).and.
     &     lgtgbe.ge.(5.5/29.-sqrt(25./1038.))) then
         excl=ibset(excl,5)
      endif
c        h3 pdg 94 p 1370 iii adriani92 l3
      if (mass(kh3).lt.22.d0 .and. tanbe.gt.1.0.and.tanbe.lt.50.0)
     &   excl=ibset(excl,5)
c...pu update 00-03-10 limit implemented from opal document pn426
c...http://www.cern.ch/opal/pubs/latest_docs.html
      if(mass(kh3).lt.80.1d0) excl=ibset(excl,5)


c h2:
c...pu update 00-03-10 limit implemented from aleph 2000-006
c...http://alephwww.cern.ch/alpub/oldconf/oldconf_00.html
      beta=atan(tanbe)
      y=sin(beta-alpha)**2
      if(mass(kh2).lt.arrmh2(1)) then
        excl=ibset(excl,5)
        goto 440
      elseif(mass(kh2).gt.arrmh2(25)) then
        goto 440
      else
        ylim=0.0d0
        do iiikkk=1,24
          if(mass(kh2).lt.arrmh2(iiikkk+1).and
     &        .mass(kh2).ge.arrmh2(iiikkk)) then
            ylim=arrsin2ba(iiikkk)+(arrsin2ba(iiikkk+1)
     &        -arrsin2ba(iiikkk))*(mass(kh2)-arrmh2(iiikkk))
     &        /(arrmh2(iiikkk+1)-arrmh2(iiikkk))
            goto 444
          endif
        enddo
 444    if(y.lt.ylim) excl=ibset(excl,5)
      endif
 440  continue


c...for large tan(beta) check against the cdf limit as well
c...fermilab-conf-99/263-e presented at the hep conference in
c...in tampere, july 99
c...approximate limit in the plane tan(beta) mh2 in case of maximal
c...mixing, nearly coincident (for tan(beta)<60) with no-mixing case
      mh2lim=0.0d0
      if(tanbe.ge.arrtanbe(1).and.tanbe.lt.arrtanbe(13)) then
        do iiikkk=1,12
        if(tanbe.lt.arrtanbe(iiikkk+1)
     &         .and.tanbe.ge.arrtanbe(iiikkk)) then
          mh2lim=arrmh2cd(iiikkk)+(arrmh2cd(iiikkk+1)
     &            -arrmh2cd(iiikkk))*(tanbe-arrtanbe(iiikkk))
     &     /(arrtanbe(iiikkk+1)-arrtanbe(iiikkk))
          goto 555
        endif
      enddo
 555  if (mass(kh2).lt.mh2lim) excl=ibset(excl,5)
      endif


c hc:
c...pu update 00-03-10. limit implemented from aleph 2000-011
c...http://alephwww.cern.ch/alpub/oldconf/oldconf_00.html
      if (mass(khc).lt.77.7d0) excl=ibset(excl,5)

c-----------------------------------------bound from gamma_z(invisible)
      mz = mass(kz)
      mz2 = mz*mz
      ! 3 neutrinos
      gzinv = (g2weak/2/costhw)**2 * mz/(24.d0*pi)
      ! 3 sneutrinos
      do i=1,3
         temp = 1.d0-4.d0*mass(ksnu(i))**2/mz2
         if (temp.gt.0.d0) then
            temp = temp**(1.5d0) *
     &           (g2weak/2/costhw)**2 * mz/(48.d0*pi)
            gzinv = gzinv + temp
         endif
      enddo
      ! neutralinos
c...pg fixed june 30, 2000
      do i=1,4
         mi = abs(mass(kn(i)))
         do j=i,4
            mj = abs(mass(kn(j)))
            p2 = (mz2-(mi+mj)**2)*(mz2-(mi-mj)**2)/(4*mz2)
            ei = (mz2-mj**2+mi**2)/(2*mz)
            ej = (mz2-mi**2+mj**2)/(2*mz)
            if (p2.gt.0.d0.and.ei.gt.0.0d0.and.ej.gt.0.0d0) then
               gzij = g2weak/(2.d0*costhw)*
     &              (conjg(neunmx(i,3))*neunmx(j,3)-
     &               conjg(neunmx(i,4))*neunmx(j,4))
               temp=sqrt(p2)/(2.d0*pi*mz2) * (
     &              dsabsq(gzij) * (ei*ej+p2/3.0d0)-
     &              dreal(gzij**2)*mi*mj)
               if (i.eq.j) temp=0.5d0*temp
               gzinv = gzinv + temp
            endif
         enddo
      enddo
c        pdg 94 p 1358 (498.2+4.2)
      if (gzinv.gt.0.5024d0) excl=ibset(excl,4)

c   reason for exclusion
 1000 continue
      if (prtlevel.ge.1) call dswexcl(6,excl)
      return

c--------------------------------------------limit on the rho parameter
c...je addition 2000-04-24
c...uses delta rho as calculated by feynhiggs
      if (delrho.gt.1.3d-3) then
        excl=ibset(excl,8)
      endif


      end

      subroutine dsacbnd3(excl)
c_______________________________________________________________________
c  check if accelerator data exclude the present point.
c  output:
c    excl - code of the reason for exclusion (integer); 0 if allowed
c    if not allowed, the reasons are coded as follows
c      dsbit set   dec.   oct.   reason
c      -------   ----   ----   ------
c            0      1      1   chargino mass
c            1      2      2   gluino mass
c            2      4      4   squark mass
c            3      8     10   slepton mass
c            4     16     20   invisible z width
c            5     32     40   higgs mass
c            6     64    100   neutralino mass
c            7    128    200   b -> s gamma
c            8    256    400   rho parameter
c  common:
c    'dssusy.h' - file with susy common blocks
c  author: paolo gondolo 1994-1999
c  history:
c     940407 first version paolo gondolo
c     950323 update paolo gondolo
c     971200 partial update joakim edsjo
c     980428 update joakim edsjo
c     990719 update paolo gondolo
c     000310 update piero ullio
c     000424 added delrho joakim edsjo
c     000904 update according to pdg2000 lars bergstrom      
c     010214 mh2 limits corrected, joakim edsjo
c=======================================================================
      implicit none
      include 'dssusy.h'
      integer i,j,excl
      logical excluded
      real*8 gzinv,temp,mi,mj,ei,ej,p2,mz,mz2,dsabsq,bsg,
     &  beta,y,mh2lim
      complex*16 gzij
      real*8 diffneucha,absmacha,arrmh2(25),
     & arrsin2ba(25),arrmh2cd(13),arrtanbe(13),ylim
      integer iiikkk

      data (arrmh2(i),i=1,25)/
     & 0.914500d+02,0.924500d+02,0.936000d+02,0.944500d+02,
     & 0.955000d+02,0.960000d+02,0.979000d+02,0.990500d+02,
     & 0.100750d+03,0.101050d+03,0.102050d+03,0.102800d+03,
     & 0.103300d+03,0.103900d+03,0.104350d+03,0.105100d+03, ! JE fix 010212
     & 0.105800d+03,0.106250d+03,0.106700d+03,0.106850d+03,
     & 0.107000d+03,0.107100d+03,0.107350d+03,0.107450d+03,
     & 0.107700d+03/

      data (arrsin2ba(i),i=1,25)/
     & 0.000d0,0.050d0,0.150d0,0.200d0,0.213d0,0.200d0,0.187d0,
     & 0.187d0,0.200d0,0.213d0,0.250d0,0.300d0,0.350d0,0.400d0,
     & 0.450d0,0.500d0,0.550d0,0.600d0,0.650d0,0.700d0,0.750d0,
     & 0.800d0,0.850d0,0.900d0,1.000d0/

      data (arrtanbe(i),i=1,13)/46.d0,48.d0,49.d0,50.d0,52.d0,53.d0
     & ,55.d0,55.8d0,56.d0,57.d0,58.d0,59.d0,60.d0/

      data (arrmh2cd(i),i=1,13)/90.d0,92.d0,94.d0,95.d0,96.d0,98.d0
     & ,100.d0,102.d0,104.d0,106.d0,108.d0,110.d0,112.d0/

      excl=0

c----------------------------------------------bounds from b -> s gamma
      call dsbsgamma(bsg,bsgqcd)
      if (bsg.lt.1.00d-4.or.bsg.gt.4.0d-4) then
         excl=ibset(excl,7)
      endif

c------------------------------------------lower bound on chargino mass
c  ... lbe update 000904 to pdg2000             
      diffneucha=abs(mass(kn(1))-mass(kcha(2)))
      absmacha=abs(mass(kcha(2)))
c ...  lbe, pdg2000, l3 limit:
      if (absmacha.lt.67.7d0) excl=ibset(excl,0) 
c ... the following is from pdg2000, abreu et al (delphi):      
      if (absmacha.lt.88.4d0.and.diffneucha.ge.3.d0
     & .and.tanbe.ge.1.d0.and.mass(ksnu(1)).ge.mass(kcha(1)))
     &  excl=ibset(excl,0)
c        pdg 94 p 1801 iv hidaka91 cdf 
c      if (abs(mass(kcha(1))).lt.99.0d0) excl=ibset(excl,0)

c--------------------------------------------lower bound on gluino mass
c  ... lbe update 000904 to pdg2000; use only limit with cascade decays:
      if (mass(kgluin).lt.173.d0) excl=ibset(excl,1)
c      excluded=.false.
c      do i=1,6
c        excluded = excluded .or. (mass(ksqu(i)).lt.mass(kgluin)) .or.
c     &        (mass(ksqd(i)).lt.mass(kgluin))
c      enddo
c      if (excluded .and. mass(kgluin).lt.260.0d0) excl=ibset(excl,1)

c------------------------------------------lower bound on squark masses
c  ... lbe update 000904 to pdg2000             
      excluded=.false.
      do i=1,6 ! aleph limit, pdg2000
        excluded = excluded .or. (mass(ksqu(i)).lt.92.d0) .or.
     &        (mass(ksqd(i)).lt.92.d0)
      enddo
      if (excluded .and. mass(kgluin)-mass(kn(kln)).lt.10.0d0)
     &  excl=ibset(excl,2)
c        pdg 94 abachi95 d0 prl75,618 is 176 with mgluino<300
      excluded=.false.
      do i=1,6 ! cdf limit, pdg2000
        excluded = excluded .or.
     &    (mass(ksqu(i)).lt.224.d0 .and. mass(ksqu(i)).gt.mass(kgluin))
     &    .or.
     &    (mass(ksqu(i)).lt.224.d0 .and. mass(ksqd(i)).gt.mass(kgluin))
      enddo
      if (excluded) excl=ibset(excl,2)

c---------------------------------lower bound on charged slepton masses
c  ... lbe update 000904 to pdg2000
      excluded=.false.
      do i=1,6 ! lep, pdg2000
        excluded = excluded .or. (mass(ksl(i)).lt.41.d0)
        enddo
c ... opal limits, pdg2000:        
      if (mass(ksl(1)).lt.87.1d0 .and. abs(mass(kn(kln))).lt.82.1d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(2)).lt.87.1d0 .and. abs(mass(kn(kln))).lt.82.1d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(3)).lt.82.3d0 .and. abs(mass(kn(kln))).lt.79.3d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(4)).lt.82.3d0 .and. abs(mass(kn(kln))).lt.79.3d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(5)).lt.81.0d0 .and. abs(mass(kn(kln))).lt.73.d0)
     &     excl=ibset(excl,3)
      if (mass(ksl(6)).lt.81.0d0 .and. abs(mass(kn(kln))).lt.73.d0)
     &     excl=ibset(excl,3)

c---------------------------------------lower bound on sneutrino masses
c ... lbe update 000904 to pdg2000 "unpublished lep limits":
      if (mass(ksnu(1)).lt.43.7d0) excl=ibset(excl,3)
      if (mass(ksnu(2)).lt.43.7d0) excl=ibset(excl,3)
      if (mass(ksnu(3)).lt.43.7d0) excl=ibset(excl,3)

c-------------------------------------lower bounds on neutralino masses
c     assumes neutralinos are ordered by increasing mass
c ... lbe update 000904, pdg2000
      if (abs(mass(kn(1))).lt.32.5d0) excl=ibset(excl,6)
      if (abs(mass(kn(2))).lt.55.9d0.and.
     &    abs(abs(mass(kn(2)))-abs(mass(kn(1)))).gt.10.d0.and.
     &    tanbe.ge.1.5d0)
     &    excl=ibset(excl,6)
      if (abs(mass(kn(3))).lt.106.6d0.and.
     &    abs(abs(mass(kn(2)))-abs(mass(kn(1)))).gt.10.d0.and.
     &    tanbe.gt.1.5d0)
     &    excl=ibset(excl,6)
c        pdg 99 abbiendi99 opal epj c8,255
      if (abs(mass(kn(2))).lt.44.0d0) excl=ibset(excl,6)
c        pdg 99 abbiendi99 opal epj c8,255
      if (abs(mass(kn(3))).lt.102.d0) excl=ibset(excl,6)
c        pdg 99 acciarri95 l3 plb350,109
      if (abs(mass(kn(4))).lt.127.0d0) excl=ibset(excl,6)

c------------------------------------------------bounds on higgs masses
c h3:
c ... lbe update, pdg2000 delphi limit:
      if(mass(kh3).lt.84.1d0) excl=ibset(excl,5)


c h2:
c...pu update 00-03-10 limit implemented from aleph 2000-006
c...http://alephwww.cern.ch/alpub/oldconf/oldconf_00.html
c...Corrected, JE 2001-02-14
      beta=atan(TanBe)
      y=sin(beta-alpha)**2
      if(mass(kh2).lt.arrmh2(1)) then
        Excl=ibset(Excl,5)
        goto 440
      elseif(mass(kh2).gt.arrmh2(25)) then
        goto 440
      else  
        do iiikkk=1,24
          if(mass(kh2).lt.arrmh2(iiikkk+1).and
     &        .mass(kh2).ge.arrmh2(iiikkk)) then
            ylim=arrsin2ba(iiikkk)+(arrsin2ba(iiikkk+1)
     &        -arrsin2ba(iiikkk))*(mass(kh2)-arrmh2(iiikkk))
     &        /(arrmh2(iiikkk+1)-arrmh2(iiikkk)) 
            goto 444
          endif
        enddo
 444    if(y.gt.ylim) Excl=ibset(Excl,5)   ! JE corr 2001-02-14
      endif  
 440  continue

c...for large tan(beta) check against the cdf limit as well
c...fermilab-conf-99/263-e presented at the hep conference in
c...in tampere, july 99
c...approximate limit in the plane tan(beta) mh2 in case of maximal
c...mixing, nearly coincident (for tan(beta)<60) with no-mixing case
      mh2lim=0.0d0
      if(tanbe.ge.arrtanbe(1).and.tanbe.lt.arrtanbe(13)) then
        do iiikkk=1,12
        if(tanbe.lt.arrtanbe(iiikkk+1)
     &         .and.tanbe.ge.arrtanbe(iiikkk)) then
          mh2lim=arrmh2cd(iiikkk)+(arrmh2cd(iiikkk+1)
     &            -arrmh2cd(iiikkk))*(tanbe-arrtanbe(iiikkk))
     &     /(arrtanbe(iiikkk+1)-arrtanbe(iiikkk))
          goto 555
        endif
      enddo
 555  if (mass(kh2).lt.mh2lim) excl=ibset(excl,5)
      endif


c hc:

c...pu update 00-03-10. limit implemented from aleph 2000-011
c...http://alephwww.cern.ch/alpub/oldconf/oldconf_00.html      
c      if (mass(khc).lt.77.7d0) excl=ibset(excl,5)
c ... lbe update, pdg2000, d0 limit:
      if (mass(khc).lt.82.8d0) excl=ibset(excl,5)      
c-----------------------------------------bound from gamma_z(invisible)
      mz = mass(kz)
      mz2 = mz*mz
      ! 3 neutrinos
      gzinv = (g2weak/2/costhw)**2 * mz/(24.d0*pi)
      ! 3 sneutrinos
      do i=1,3
         temp = 1.d0-4.d0*mass(ksnu(i))**2/mz2
         if (temp.gt.0.d0) then
            temp = temp**(1.5d0) *
     &           (g2weak/2/costhw)**2 * mz/(48.d0*pi)
            gzinv = gzinv + temp
         endif
      enddo
      ! neutralinos
c...pg fixed june 30, 2000
      do i=1,4
         mi = abs(mass(kn(i)))
         do j=i,4
            mj = abs(mass(kn(j)))
            p2 = (mz2-(mi+mj)**2)*(mz2-(mi-mj)**2)/(4*mz2)
            ei = (mz2-mj**2+mi**2)/(2*mz)
            ej = (mz2-mi**2+mj**2)/(2*mz)
            if (p2.gt.0.d0.and.ei.gt.0.0d0.and.ej.gt.0.0d0) then
               gzij = g2weak/(2.d0*costhw)*
     &              (conjg(neunmx(i,3))*neunmx(j,3)-
     &               conjg(neunmx(i,4))*neunmx(j,4))
               temp=sqrt(p2)/(2.d0*pi*mz2) * (
     &              dsabsq(gzij) * (ei*ej+p2/3.0d0)-
     &              dreal(gzij**2)*mi*mj)
               if (i.eq.j) temp=0.5d0*temp
               gzinv = gzinv + temp
            endif
         enddo
      enddo
c        pdg 94 p 1358 (498.2+4.2)
      if (gzinv.gt.0.5024d0) excl=ibset(excl,4)

c   reason for exclusion
 1000 continue
      if (prtlevel.ge.1) call dswexcl(6,excl)
      return

c--------------------------------------------limit on the rho parameter
c...je addition 2000-04-24
c...uses delta rho as calculated by feynhiggs
      if (delrho.gt.1.3d-3) then
        excl=ibset(excl,8)
      endif


      end

      subroutine dsacset(a)
      implicit none
      include 'dsaccom.h'
      character*(*) a
      aclabel = a
      return
      end

      subroutine dsbsgamma(ratio,flag)
c_______________________________________________________________________
c  b -> s + gamma branching ratio
c  common:
c    'dssusy.h' - file with susy common blocks
c  input:
c    flag : 0 no qcd correction -- 1 qcd corrections
c  output:
c    ratio : branching ratio
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994,1995
c     28-nov-94 formulas in bertolini et al, nucl phys b353 (1991) 591
c     modified: joakim edsjo, 2000-09-03, vertices from dsvertx.f
c     correctly implemented
c=======================================================================
      implicit none
      include 'dssusy.h'
      real*8 ratio
      integer flag
      real*8 dsbsgf1,dsbsgf2,dsbsgf3,dsbsgf4,eu,ed,xtw,xth,xcu,xgd,xnd
      real*8 eta,lambda,rho,f,r,gfermi2b,alphemb,alphwb,alph3b,
     &     gexp,gbsg,gbcenu,dsabsq
      complex*16 aw,ah,ac(2),ag,an(4),aa,a0
      integer k,c,j,g
      complex*16 coeff,temp1,temp2
      complex*16 glscf,grscf,gjll,gjlr,gjrl,gjrr

      ratio = 0.d0
      if (dsabsq(ckm(2,3)).eq.0.d0) return

      alphemb = 1.d0/137.d0
      alphwb = alphemb/s2thw
      eta = 1.d0/0.548d0        ! eta = alph3(mb)/alph3(mw)
      alph3b = alph3*eta
      gfermi2b = 2.d0*(4.d0*pi*alphwb)**2/mass(kw)**4/64.d0
      eu = echarg(ku)
      ed = echarg(kd)

c------------------------- couplings from dsvertx.f, to avoid calling it
      do k=1,6
        do g=1,3
          do c=1,2
            glscf = dcmplx(0.d0,0.d0)
            grscf = dcmplx(0.d0,0.d0)
            do j=1,3
              glscf = glscf -
     &          (conjg(chavmx(c,2))*squrmx(k,j)*yukawa(kqu(j))-
     &           g2weak*conjg(chavmx(c,1))*squlmx(k,j))*ckm(j,g)
              grscf = grscf -
     &          chaumx(c,2)*squlmx(k,j)*ckm(j,g)*yukawa(kqd(g))
            enddo
            gl(ksqu(k),kcha(c),kqd(g))=glscf
            gr(ksqu(k),kcha(c),kqd(g))=grscf
          enddo
          gl(ksqd(k),kgluin,kqd(g)) = -sqrt(2.d0)*g3stro*sqdlmx(k,g)
          gr(ksqd(k),kgluin,kqd(g)) = +sqrt(2.d0)*g3stro*sqdrmx(k,g)
          do j=1,4
            gjll=-(-g2weak*neunmx(j,2)+
     &       gyweak*neunmx(j,1)/3.0d0)/sqrt(2.0d0)
            gjlr=-yukawa(kqd(g))*neunmx(j,3)
            gjrl=-yukawa(kqd(g))*neunmx(j,3)
            gjrr=sqrt(2.0d0)*echarg(kd)*gyweak*neunmx(j,1)
            gl(ksqd(k),kn(j),kqd(g))=
     &           conjg(gjll)*sqdlmx(k,g)+conjg(gjrl)*sqdrmx(k,g)
            gr(ksqd(k),kn(j),kqd(g))=
     &           gjlr*sqdlmx(k,g)+gjrr*sqdrmx(k,g)
          enddo
        enddo
      enddo

c-------------------------------------------------------- b -> c e nubar
      gexp = 0.107d0
      r = mass(kc)/mass(kb)
      rho = 1.d0-8.d0*r*r+8.d0*r**6-r**8-24.d0*r**4*dlog(r)
      f = 2.41d0
      if (flag.ne.0) then
         lambda = 1.d0-(2.d0/3.d0)*f*alph3*eta/pi
      else
         lambda = 1.d0
      endif
      lambda = 1.d0-(2.d0/3.d0)*f*alph3b/pi
      gbcenu = gfermi2b/(192.d0*pi**3)*rho*lambda* ! without mb**5
     &     (ckm(2,3)*conjg(ckm(2,3)))

      coeff = (alphwb/2.d0)*dsqrt(alphemb/pi) * 1/mass(kw)**2 *
     &     conjg(ckm(3,2))*ckm(3,3)

c-------------------------------------------------------------------- w+
      xtw = (mass(kt)/mass(kw))**2
      aw = (alphwb/4.d0)*dsqrt(alphemb/pi) * 1.d0/mass(kw)**2 *
     &     conjg(ckm(3,2))*ckm(3,3) *
     &     3*xtw*(eu*dsbsgf1(xtw)+dsbsgf2(xtw))

c--------------------------------------------------------- charged higgs
      xth = (mass(kt)/mass(khc))**2
      ah = (alphwb/4.d0)*dsqrt(alphemb/pi) * 1.d0/mass(kw)**2 *
     &     conjg(ckm(3,2))*ckm(3,3) *
     &     xth*((eu*dsbsgf1(xth)+dsbsgf2(xth))/tanbe**2
     &         +(eu*dsbsgf3(xth)+dsbsgf4(xth)))

c-------------------------------------------------------------- chargino
      do c=1,2
         ac(c) = cmplx(0.d0,0.d0)
         do k=1,6
            xcu = (mass(kcha(c))/mass(ksqu(k)))**2
            temp1 =  - (alphwb/2.d0)*dsqrt(alphemb/pi) *
     &           1.d0/mass(ksqu(k))**2 * (1.d0/g2weak**2) *
     &           (gl(ksqu(k),kcha(c),kb)*conjg(gl(ksqu(k),kcha(c),ks))*
     &                    (dsbsgf1(xcu)+eu*dsbsgf2(xcu)))
            temp2 =  - (alphwb/2.d0)*dsqrt(alphemb/pi) *
     &           1.d0/mass(ksqu(k))**2 * (1.d0/g2weak**2) *
     &           (gr(ksqu(k),kcha(c),kb)*conjg(gl(ksqu(k),kcha(c),ks))*
     &                    (mass(kcha(c))/mass(kb))*
     &                    (dsbsgf3(xcu)+eu*dsbsgf4(xcu)))
            ac(c) = ac(c) + temp1 + temp2
         enddo
      enddo

c---------------------------------------------------------------- gluino
      ag = cmplx(0.d0,0.d0)
      do k=1,6
         xgd = (mass(kgluin)/mass(ksqd(k)))**2
         ag = ag - alph3b*dsqrt(alphemb/pi) * (4.d0/3.d0) * ed *
     &        1.d0/(mass(ksqd(k)))**2 * (1.d0/(2.d0*g3stro**2)) *
     &        (gl(ksqd(k),kgluin,kb)*conjg(gl(ksqd(k),kgluin,ks))*
     &                             dsbsgf2(xgd)
     &        +gr(ksqd(k),kgluin,kb)*conjg(gl(ksqd(k),kgluin,ks))*
     &                (mass(kgluin)/mass(kb))*
     &                             dsbsgf4(xgd))
      enddo

c----------------------------------------------------------- neutralino
      do j=1,4
         an(j) = cmplx(0.d0,0.d0)
         do k=1,6
            xnd = (mass(kn(j))/mass(ksqd(k)))**2
            an(j) = an(j) - (alphwb/2.d0)*dsqrt(alphemb/pi) * ed *
     &           1.d0/(mass(ksqd(k)))**2 * (1.d0/g2weak**2) *
     &           (gl(ksqd(k),kn(j),kb)*conjg(gl(ksqd(k),kn(j),ks))*
     &                             dsbsgf2(xnd)
     &           +gr(ksqd(k),kn(j),kb)*conjg(gl(ksqd(k),kn(j),ks))*
     &                 (mass(kn(j))/mass(kb))*
     &                             dsbsgf4(xnd))
         enddo
      enddo

c---------------------------------------------------------- b -> s gamma
      aa = aw+ah+ac(1)+ac(2)+ag+an(1)+an(2)+an(3)+an(4)
      if (prtlevel.ge.2) then
         write (*,*) 'bsgamma: aw=',aw/coeff
         write (*,*) '       : ah=',ah/coeff
         write (*,*) '       : ac(1)=',ac(1)/coeff
         write (*,*) '       : ac(2)=',ac(2)/coeff
         write (*,*) '       : ag=',ag/coeff
         write (*,*) '       : an(1)=',an(1)/coeff
         write (*,*) '       : an(2)=',an(2)/coeff
         write (*,*) '       : an(3)=',an(3)/coeff
         write (*,*) '       : an(4)=',an(4)/coeff
      endif
      if (flag.ne.0) then
         a0 = (alphwb/4.d0)*dsqrt(alphemb/pi) * 1.d0/mass(kw)**2 *
     &     conjg(ckm(3,2))*ckm(3,3)
         aa = eta**(-16.d0/23.d0) * ( aa + a0 *
     &        (116.d0/135.d0*(eta**(10.d0/23.d0)-1.d0)
     &        +58.d0/189.d0*(eta**(28.d0/35.d0)-1.d0)) )
      endif
      gbsg = 1.d0/(16.d0*pi) * (aa*conjg(aa)) ! without mb**5

c---------------------- normalization of b -> s gamma to b -> c e nubar
      ratio = gexp * (gbsg/gbcenu)

      end
      function dsbsgf1(x)
c_______________________________________________________________________
c  function in bertolini et al, nucl phys b353 (1991) 591
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994
c=======================================================================
      implicit none
      real*8 dsbsgf1,x,y,res
      y = x-1.d0
      if (abs(y).lt.0.01) then
         res = (1.d0-0.6*y+0.4*y**2)/24.d0
      else if (x.lt.1.d-4) then
         res = 1.d0/6.d0
      else
         res = (x**3-6*x**2+3*x+2+6*x*log(x))/(12.*(x-1)**4)
      endif
      dsbsgf1 = res
      end
      function dsbsgf2(x)
c_______________________________________________________________________
c  function in bertolini et al, nucl phys b353 (1991) 591
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994
c=======================================================================
      implicit none
      real*8 dsbsgf2,x,y,res
      y = x-1.d0
      if (abs(y).lt.0.01) then
         res = (1.d0-0.4*y+0.2*y**2)/24.d0
      else if (x.lt.1.d-4) then
         res = 1.d0/12.d0-x/6.d0
      else
         res = (2*x**3+3*x**2-6*x+1-6*x**2*log(x))/(12.*(x-1)**4)
      endif
      dsbsgf2 = res
      end
      function dsbsgf3(x)
c_______________________________________________________________________
c  function in bertolini et al, nucl phys b353 (1991) 591
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994
c=======================================================================
      implicit none
      real*8 dsbsgf3,x,y,res
      y = x-1.d0
      if (abs(y).lt.0.01) then
         res = (1.d0-0.75d0*y+0.6d0*y**2)/3.d0
      else if (x.lt.1.d-4) then
         res = -1.5d0-log(x)
      else
         res = (x**2-4*x+3+2*log(x))/(2.*(x-1)**3)
      endif
      dsbsgf3 = res
      end
      function dsbsgf4(x)
c_______________________________________________________________________
c  function in bertolini et al, nucl phys b353 (1991) 591
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994
c=======================================================================
      implicit none
      real*8 dsbsgf4,x,y,res
      y = x-1.d0
      if (abs(y).lt.0.01) then
         res = (1.d0-0.5d0*y+0.3d0*y**2)/6.d0
      else if (x.lt.1.d-4) then
         res = 0.5d0
      else
         res = (x**2-1-2*x*log(x))/(2.*(x-1)**3)
      endif
      dsbsgf4 = res
      end
      subroutine dsgminus2(gm2amp)
c_______________________________________________________________________
c  muon g-2 amplitude
c  common:
c    'dssusy.h' - file with susy common blocks
c  output:
c    gm2amp : susy contribution to g-2 amplitude  = (g-2)/2
c  author: Lars Bergstrom (lbe@physto.se) february, 2001
c     uses formulas from T. Moroi, PRD 1996; (E) 1997
c=======================================================================
      implicit none
      include 'dssusy.h'
      complex*16 delasmuon,delachargino,gm2comp
      real*8 xax,xx,gm2amp
      real*8 mumass,prefactor
      integer j,k,c
      complex*16 nlax,nrax,clx,crx
      mumass=mass(kl(2))
c      write(*,*) mumass
      prefactor=mumass/16.d0/(4.d0*datan(1.d0))**2
      delasmuon=cmplx(0.d0,0.d0)
      delachargino=cmplx(0.d0,0.d0)
      do 20 k=3,4        ! smuons
         do 10 j=1,4     ! neutralinos
            nlax=gl(kl(2),ksl(k),kn(j))
            nrax=gr(kl(2),ksl(k),kn(j))
            xax=(mass(kn(j))/mass(ksl(k)))**2
            delasmuon=delasmuon-
     & mumass/(6.d0*mass(ksl(k))**2*(1.d0-xax)**4)*
     & (nlax*nlax+nrax*nrax)*
     & (1.d0-6.d0*xax+3.d0*xax**2+2.d0*xax**3-
     & 6.d0*xax**2*log(xax))-
     & mass(kn(j))/(mass(ksl(k))**2*(1.d0-xax)**3)*
     & nlax*nrax*(1.d0-xax**2+2.d0*xax*log(xax))
 10         continue
 20         continue
      do 30 c=1,2
      clx=gl(kl(2),ksnu(2),kcha(c))
      crx=gr(kl(2),ksnu(2),kcha(c))      
      xx=mass(kcha(c))**2/mass(ksnu(2))**2
      delachargino=delachargino+
     & mumass/(3.d0*mass(ksnu(2))**2*(1.d0-xx)**4)*
     & (clx*clx+crx*crx)*
     & (1.d0+1.5d0*xx-3.d0*xx**2+.5d0*xx**3+3.d0*xx*log(xx))-     
     & 3.d0*mass(kcha(c))/(mass(ksnu(2))**2*(1.d0-xx)**3)*
     & clx*crx*(1.d0-4.d0/3.d0*xx+xx**2/3.d0+2.d0/3.d0*log(xx))
 30    continue
      gm2comp=prefactor*(delasmuon+delachargino)
      if (abs(imag(gm2comp)).gt.1.d-20) then
        write(*,*) 'ERROR in dsgminus2: complex amplitude: ',gm2comp
      endif
      gm2amp=dble(gm2comp)
   
      return
      end
      subroutine dswexcl(unit,excl)
c_______________________________________________________________________
c  write reasons for exclusion to specified unit.
c  input:
c    unit - logical unit to write on (integer)
c    excl - code of the reason for exclusion (integer); 0 if allowed
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994
c=======================================================================
      implicit none
      include 'dssusy.h'
      integer unit,excl
      character*12 dsidtag
      if (unit.le.0) return
      if (excl.eq.0) return
      write (unit,1001) dsidtag(),' excluded by: '
      if (btest(excl,0)) write (unit,1000) 'chargino mass; '
      if (btest(excl,1)) write (unit,1000) 'gluino mass; '
      if (btest(excl,2)) write (unit,1000) 'squark mass; '
      if (btest(excl,3)) write (unit,1000) 'slepton mass; '
      if (btest(excl,4)) write (unit,1000) 'gamma_z(inv); '
      if (btest(excl,5)) write (unit,1000) 'h2 mass; '
      if (btest(excl,6)) write (unit,1000) 'neutralino mass; '
      if (btest(excl,7)) write (unit,1000) 'b->s+gamma; '
      if (btest(excl,8)) write (unit,1000) 'delta rho; '
      write (unit,*)
 1000 format (1x,a,$)
 1001 format (1x,'(',a,')',1x,a,$)
      end
