      subroutine dsgminus2(gm2amp)
c_______________________________________________________________________
c  muon g-2 amplitude
c  common:
c    'dssusy.h' - file with susy common blocks
c  output:
c    gm2amp : susy contribution to g-2 amplitude  = (g-2)/2
c  author: Lars Bergstrom (lbe@physto.se) february, 2001
c     uses formulas from T. Moroi, PRD 1996; (E) 1997
c=======================================================================
      implicit none
      include 'dssusy.h'
      complex*16 delasmuon,delachargino,gm2comp
      real*8 xax,xx,gm2amp
      real*8 mumass,prefactor
      integer j,k,c
      complex*16 nlax,nrax,clx,crx
      mumass=mass(kl(2))
c      write(*,*) mumass
      prefactor=mumass/16.d0/(4.d0*datan(1.d0))**2
      delasmuon=cmplx(0.d0,0.d0)
      delachargino=cmplx(0.d0,0.d0)
      do 20 k=3,4        ! smuons
         do 10 j=1,4     ! neutralinos
            nlax=gl(kl(2),ksl(k),kn(j))
            nrax=gr(kl(2),ksl(k),kn(j))
            xax=(mass(kn(j))/mass(ksl(k)))**2
            delasmuon=delasmuon-
     & mumass/(6.d0*mass(ksl(k))**2*(1.d0-xax)**4)*
     & (nlax*nlax+nrax*nrax)*
     & (1.d0-6.d0*xax+3.d0*xax**2+2.d0*xax**3-
     & 6.d0*xax**2*log(xax))-
     & mass(kn(j))/(mass(ksl(k))**2*(1.d0-xax)**3)*
     & nlax*nrax*(1.d0-xax**2+2.d0*xax*log(xax))
 10         continue
 20         continue
      do 30 c=1,2
      clx=gl(kl(2),ksnu(2),kcha(c))
      crx=gr(kl(2),ksnu(2),kcha(c))      
      xx=mass(kcha(c))**2/mass(ksnu(2))**2
      delachargino=delachargino+
     & mumass/(3.d0*mass(ksnu(2))**2*(1.d0-xx)**4)*
     & (clx*clx+crx*crx)*
     & (1.d0+1.5d0*xx-3.d0*xx**2+.5d0*xx**3+3.d0*xx*log(xx))-     
     & 3.d0*mass(kcha(c))/(mass(ksnu(2))**2*(1.d0-xx)**3)*
     & clx*crx*(1.d0-4.d0/3.d0*xx+xx**2/3.d0+2.d0/3.d0*log(xx))
 30    continue
      gm2comp=prefactor*(delasmuon+delachargino)
      if (abs(imag(gm2comp)).gt.1.d-20) then
        write(*,*) 'ERROR in dsgminus2: complex amplitude: ',gm2comp
      endif
      gm2amp=dble(gm2comp)
   
      return
      end
