**********************************************************************
*** function dsansigmav returns the annihilation cross section
*** sigma v at p=0 for neutralino-neutralino annihilation.
*** if partch=0, the full sigma v is obtained and if partch>0, the
*** cross section to channel partch is obtained.
*** units: cm^-3 s^-1
**********************************************************************

      function dsansigmav(partch)
      implicit none
      real*8 dsansigmav
      integer partch
      include 'dssusy.h'
      include 'dshacom.h'
      include 'dsidtag.h'
      include 'dsprep.h'
      
      if (.not.dsprepcalled) then
        write(*,*) 'error in dsansigmav: dsprep must be called',
     &    ' before any rate calculation'
        write(*,*) 'begins for every new model. program stopping.'
      endif

      dsansigmav=sigmav
      if (partch.gt.0) dsansigmav=sigv(partch)
      return

      end
