      function dsddu_eff(atomw,mx,vesc,vobs,sigma,vcut,iform,icapt)
c_______________________________________________________________________
c effective speed for direct ditection and capture rates
c it is defined in such a way that the rate is
c   (rate) = (#nucleons) * (cross section on nucleon) * (u_eff)
c
c        iform = 1 pointlike
c                2 gaussian
c
c        icapt = 0 direct detection, 1 capture rate
c
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994,1995
c=======================================================================
      implicit none
      real*8 dsddu_eff,atomw,mx,vesc,vobs,sigma,vcut
      integer iform,icapt
      real*8 mi,amu
      parameter (amu=0.93149432d0)
      real*8 cvobs,cvcut,csigma,cvesc,cmx,w2max,sum,dsdduinvff,dsf_int
      external dsdduinvff
      integer ciform,cicapt
      common /xratec/ cvobs,cvcut,csigma,cvesc,mi,
     &  cmx,ciform,cicapt
      save /xratec/
      cvobs=vobs
      cvcut=vcut
      csigma=sigma
      cvesc=vesc
      cmx=mx
      ciform=iform
      cicapt=icapt
      mi=atomw*amu
      if (icapt.eq.0) then
        w2max=(vobs+min(vcut,8.*sigma))**2+vesc**2
      else
        w2max=(vobs+min(vcut,8.*sigma))**2
      endif
      sum=dsf_int(dsdduinvff,0.d0,w2max,1.0d-3)
      dsddu_eff = sum
      end

