************************************************************************
*** This is the average of the halo density squared from
*** z=-l_h to z=+l_h.
*** It is the function f(r) given in Eq. (20) in Baltz & Edsjo, 
*** PRD 59(1999)023511, except that g(r) here is the NORMALIZED
*** halo density. Consequently, n_c=1.
*** Author: Joakim Edsjo, edsjo@physto.se
*** Date: 2000-09-03
************************************************************************

************************************************************************
      real*8 function dsepf(r)
************************************************************************
      implicit none
      include 'dsepcom.h'
      real*8 r,dsephalodens2,dsf_int
      external dsephalodens2
      r_gc = r   ! put in common block that dsephalodens2 can see
      dsepf=1.0d0/(2.0d0*l_h)*
     &  dsf_int(dsephalodens2,-1.0d0*l_h,l_h,0.01d0)
      return
      end



