************************************************************************
*** positron propagation routines.
*** author: e.a. baltz (eabaltz@astron.berkeley.edu)
*** modified slightly by joakim edsjo (edsjo@physto.se)
*** date: jun-02-98
*** modified: jun-09-98
************************************************************************


************************************************************************
      subroutine dsepmake_tables
***   creates a table of i(delta v) versus delta v.
************************************************************************
      implicit none
      include 'dsepcom.h'
      real*8 deltav,lndeltav,deltar,dsbessei0
      real*8 dv,rprime,rmin,rmax,integrand,dsepf,dsepimage_sum
      real*8 lne,egev,u
      integer i
      k0tau = k27*tau16
      ametric=1.0d0/3.0d0**alphexp
      av=ametric/(1.0d0-alphexp)
      do 30 i=1,22001
         lndeltav=real(i-1)*0.001d0-19.0d0
         deltav=exp(lndeltav)
         dv=4.0d0*k0tau*deltav
         if(dv.lt.0.4d0) then
            table(i)=dsepf(r_e)
            goto 50
         endif
         deltar=sqrt(dv)*rtol
         rmin=r_e-rwid*sqrt(dv)
         if (deltar.gt.1.0d0) deltar=1.0d0
         if (rmin.lt.0.0d0) rmin=deltar
         rmax=r_e+rwid*sqrt(dv)
         integrand=0.0d0
         rprime=rmin
 40      if(rprime.le.rmax) then
            integrand=integrand+rprime*dsepf(rprime)*
     +           dsbessei0(2.0d0*r_e*rprime/dv)*
     +           exp(-(r_e-rprime)**2/dv)
            rprime=rprime+deltar
            goto 40
         endif
         integrand=integrand*deltar/(0.5d0*dv)
         table(i)=integrand
 50      if (dv.gt.1.0d0) then
            table(i)=table(i)*dsepimage_sum(deltav)
         endif
 30   continue
      if (dsepdiffmethod.eq.1) then
         do 60 i=1,10001
            lne=real(i-1)*0.001d0
            egev=exp(lne)
            u=1.0d0/egev
            etable(i)=egev
            vtable(i)=u+av*u**(1.0d0-alphexp)
            wtable(i)=egev**2/(1+ametric*egev**alphexp)
 60      continue
      endif
      return
      end
