      subroutine dsepset(c)
c...set parameters for positron routines
c...  c - character string specifying choice to be made
c...author: joakim edsjo, 2000-07-09
c...modified: paolo gondolo, 2000-07-19
c...          joakim edsjo,  2000-08-15
      implicit none
      include 'dshmcom.h'
      include 'dsepcom.h'
      character*(*) c

c... define some internal parameters
      sumtol=0.01d0
      rtol=1.0d0
      vtol=0.01d0
      rwid=3.0d0

c... fetch some parameters from the halo model common block
      r_e=r_0           ! galactocentric distance (kpc)
      n_c = 1.0d0       ! we now have the normalization in the halo
                        ! density dshmrho directly, hence n_c=1.0

c...baltz and edsjo 1999, without low-energy cut-off in k_diff
      if (c.eq.'be99nocut') then
         dsepdiffmethod=0
         l_h=3.0d0              ! height of diffusion zone (kpc)
         tau16=1.0d0            ! energy loss = (e/gev)^2/tau (tau in 10^16 s)
         alphexp=0.6d0          ! diffusion const = k0 (e/gev)^alphexp
         k27=3.15d0             ! k0 (10^27 cm^2/s)

c...baltz and edsjo 1999, with low-energy cut-off in k_diff (default)
      else if (c.eq.'be99'.or.c.eq.'default') then
         dsepdiffmethod=1
         l_h=3.0d0              ! height of diffusion zone (kpc)
         tau16=1.0d0            ! energy loss = (e/gev)^2/tau (tau in 10^16 s)
         alphexp=0.6d0          ! diffusion const = k0 (e/gev)^alphexp
         k27=6.08952d0          ! k0 (10^27 cm^2/s)

c...kamionkowski and turner, energy dependent escape time
      else if (c.eq.'kt91') then
         dsepdiffmethod=2

c...invalid choice
      else
         write (*,*) 'dsepset: unrecognized option ',c
         stop
      endif

      return
      end
