***********************************************************************
*** note. this routine assumes a maxwell-boltzmann velocity
*** distribution and uses approximations in the jkg review.
*** for more accurate results, use dsntcapearthfull instead.
*** for any velocity distribution, use dsntcapearthnum instead.
***********************************************************************

       real*8 function dsntcapearth(mx,sigsi)
c----------------------------------------------------------------------
c         capture rate in the earth
c         based on jungman, kamionkowski, griest review
c       mx: neutralino mass
c       sigsi: spin independent cross section in units of cm^2
c       vobs: average halo velocity
c       lars bergstrom 1995-12-14
c----------------------------------------------------------------------
       implicit none
       real*8 mx,sigsi,dsntlitlf_e
       include 'dshmcom.h'
       dsntcapearth=sigsi*1.0d40*2.57d-13*3.1415/4./0.94**2 ! from sigsi to f_p
       dsntcapearth=dsntcapearth*dsntlitlf_e(mx,vobs)*2.4d28*(rhox/0.3)
       return
       end
