c  dsntcapearthnum.f:
***********************************************************************
*** dsntcapearthnum gives the capture rate of neutralinos in the earth
*** given a specified velocity distribution. the integrations over
*** the earth's radius and over the velocity distribution are
*** performed numerically
*** input: mx [ gev ]
***        sigsi [ cm^2 ]
*** output: capture rate [ s^-1 ]
*** l.b. and j.e. 1999-04-06
***********************************************************************

      real*8 function dsntcapearthnum(mx,sigsi)
      implicit none

      real*8 mx,sigsi,ma
      real*8 mxx,max,sigsix,rmin,rmax,res,dsntceint,rx
      integer imass(10),nmass,i,ix
      external dsntceint
      common/ntdkint/mxx,max,sigsix,rx
      common/ntdkint2/ix
c...perform integration as given in gould, apj 521 (1987) 571.
      mxx=mx
      sigsix=sigsi
      dsntcapearthnum=0.0d0

c...sum over elements
      nmass=4 ! only include 4 most important elements
      imass(1)=16 ! oxygen, o
      imass(2)=24 ! magnesium, mg
      imass(3)=28 ! silicon, si
      imass(4)=56 ! iron, fe
      do 10 i=1,nmass
      ma=imass(i)*.94 ! nucleus mass
      max=ma
      ix=imass(i)
c...begin radial integration
      rmin=0.d0
      rmax=6.3782d8  ! earth radius in centimeters
      call dshiprecint(dsntceint,rmin,rmax,res)
      dsntcapearthnum=dsntcapearthnum+res
 10   continue

      return
      end
