
***********************************************************************
*** l.b. and j.e. 1999-04-06
*** auxiliary function for r-integration
*** input: radius in centimeters
*** output: integrand in cm^-1 s^-1
***********************************************************************

      real*8 function dsntceint(r)
      implicit none
      real*8 mx,sigsi,mu,muplus,muminus,ma,rx
      real*8 v,res,dsntceint2,r,max,dsntearthvesc,
     &  umin,umax
      integer imass
      common/ntdkint/mx,ma,sigsi,rx
      common/ntdkint2/imass
      external dsntceint2
      include 'dsntdkcom.h'

      rx=r
      mu=mx/ma
      muplus=(mu+1.d0)/2.d0
      muminus=(mu-1.d0)/2.d0
c...begin velocity integration
c...
c...determine integration limits
      v=dsntearthvesc(r/100.0d0)   ! escape velocity at r
c...general velocity limits
      umin=0.d0                  ! lower velocity limit
      umax=sqrt(mu/muminus**2)*v ! upper velocity limit
c...velocity limits coming from the actual form of the dk distribution
c...note: change this for a different velocity distribution!!!
      umin=max(dkv_e*sqrt(1.0d0-dkeps),umin)
      umax=min(dkv_e*sqrt(3.0d0-1.0d0/2.6d0),umax)

c      write(*,*) 'umin=',umin,'  umax=',umax
      if (umin.lt.umax) then
        call dshiprecint2(dsntceint2,umin,umax,res)
        res=res*1.0d5    ! km/s -> cm/s from u integration
        dsntceint=res*r*r*4.*3.141592  ! assume spherical earth
      else
        dsntceint=0.0d0
      endif

c      if (umax.gt.30.0d0) then
c        write(*,*) 'umax=',umax,'  res=',res
c      endif

      return
      end
