

***********************************************************************
*** dsntdkcapearth calculates the capture rate at present from the
*** damour-krauss distribution of wimps. a numerical integration
*** has to be performed instead of the convenient expressions in jkg.
*** author: joakim edsjo (edsjo@physto.se)
*** date: march 18, 1999
***********************************************************************
      real*8 function dsntdkcapearth(mx,sigsi,sigsd)
      implicit none
      include 'dsntdkcom.h'
      include 'dshmcom.h'
      include 'dsntcom.h'
      real*8 mx,sigsi,sigsd
      real*8 dsntcapearthnum,dsntdkfoveru,dsntdkgtot10
      external dsntdkfoveru

c...integrate over the earth according to gould apj 321 (1987) 571.
c...set up things for radial and velocity integration

      dkgtot10=dsntdkgtot10(mx,sigsi,sigsd) ! d-k eq (5.16)
      dkmx=mx
      dkdelta_e=0.212d0/(vobs*sqrt(2.0d0/3.0d0)/220.0d0)*dkgtot10
      dklambda=ntlambda  ! get from common block
      dkeps=0.18377d0*dklambda

      gtot10=dkgtot10  ! put in result common block

c      write(*,*) 'dkgot10=',dkgtot10
c      write(*,*) 'dkmx=',dkmx
c      write(*,*) 'dkdelta_e=',dkdelta_e
c      write(*,*) 'dklambda=',dklambda
c      write(*,*) 'dkeps=',dkeps

c...perform integration
      dsntdkcapearth=dsntcapearthnum(mx,sigsi)
c      write(*,*) mx,sigsi,dsntdkcapearth

      return
      end
