

***********************************************************************
*** dsntdkfoveru is the velocity distribution for the damour-krauss
*** distribution of wimps divided by u, i.e. f(u)/u.
*** the normalization is such that int_0^infinity f(u) du = n_dk
*** where n_dk is the number density of wimps in number/cm^3.
*** author: j. edsjo (edsjo@physto.se)
*** input: velocity relative to earth [ km s^-1 ]
*** output: f(u) / u [ cm^-3 (cm^-1 s)^2 ]
*** date: april 6, 1999
***********************************************************************

      real*8 function dsntdkfoveru(u)
      implicit none
      include 'dsntdkcom.h'
      include 'dshmcom.h'

      real*8 u,n_eps,bigu,dsntdkfbigu
      parameter(n_eps=0.456579d0)

      bigu=(u/dkv_e)**2

c...first calculate f(u)/u
      dsntdkfoveru=dsntdkfbigu(bigu)*2/dkv_e**2

c...now normalize
      dsntdkfoveru=dsntdkfoveru*
     &  n_eps*(rhox/dkmx)*dkdelta_e

c...we want f(u)/u in units of cm^-3 (cm^-1 s)^2
c...we get one factor of 10^5 from each v_e (being in km/s)
      dsntdkfoveru=dsntdkfoveru*1.0d-10

c      if (u.gt.29.0d0) then
c        write(*,*) 'u=',u,'  foveru=',dsntdkfoveru
c      endif

      return
      end
