       real*8 function dsntlitlf_e(mx,vobs)
c_______________________________________________________________________
c
c    dsntlitlf_e is used by capearth to calculate the capture rate
c    in the earth.
c    mx is the neutralino mass in gev
c    written by l. bergstrom 1995-12-12
c
c=======================================================================

       implicit none
       real*8 mx,aa(9),dsntse,vobs,x,a
       real*8 m(9),f(9),phi(9),mn,dsff(9)
       integer i
       mn=0.94d0
       m(1)=16.d0*mn
       m(2)=28.d0*mn
       m(3)=24.d0*mn
       m(4)=56.d0*mn
       m(5)=40.d0*mn
       m(6)=30.d0*mn
       m(7)=23.d0*mn
       m(8)=32.d0*mn
       m(9)=59.d0*mn
       f(1)=0.3d0
       f(2)=0.15d0
       f(3)=0.14d0
       f(4)=0.3d0
       f(5)=0.015d0
       f(6)=0.011d0
       f(7)=0.004d0
       f(8)=0.05d0
       f(9)=0.03d0
       phi(1)=1.2d0
       phi(2)=1.2d0
       phi(3)=1.2d0
       phi(4)=1.6d0
       phi(5)=1.2d0
       phi(6)=1.2d0
       phi(7)=1.2d0
       phi(8)=1.6d0
       phi(9)=1.6d0
       do 10 i=1,9
         dsff(i)=1.d0
 10    continue
       x=mx/m(4)
       a=1.5d0*x/(x-1.d0)**2*(13.2d0**2/vobs**2)
       dsff(4)=1.d0-0.26d0*a/(1.d0+a)
       aa(1)=16.d0
       aa(2)=28.d0
       aa(3)=24.d0
       aa(4)=56.d0
       aa(5)=40.d0
       aa(6)=30.d0
       aa(7)=23.d0
       aa(8)=32.d0
       aa(9)=59.d0
       dsntlitlf_e=0.d0
       do 20 i=1,9
         dsntlitlf_e=dsntlitlf_e+
     &   dsff(i)*f(i)*phi(i)*dsntse(mx/m(i),vobs)
     &   *m(i)**3*mx/(mx+m(i))**2
 20    continue
       return
       end
