      subroutine dsntset(c)
c...set parameters for neutrino telescope routines
c...  c - character string specifying choice to be made
c...author: joakim edsjo, 2000-08-16
      implicit none
      include 'dsntcom.h'
      include 'dsntdkcom.h'
      character*(*) c

c... define some internal parameters

c...approximate formulae given in jungman, kamionkowski, griest.
      if (c.eq.'jkg') then
         ntcalcmet=1           ! calculate method

c...approximate as above for the sun, but the full formulae from
c...gould, apj 321 (1987) 571 for the earth
      else if (c.eq.'gould'.or.c.eq.'default') then
         ntcalcmet=2

c...approximate as above for the sun, but the full formulae from
c...gould, apj 321 (1987) 571 for the earth plus including the
c...damour-krauss distribution of wimps captured by the earth.
      else if (c.eq.'dk') then
         ntcalcmet=3
         ntlambda=1     ! amount of non-conservation of angular momentum
                        ! 1 = angular momentum conserved to 100%.

c...invalid choice
      else
         write (*,*) 'dsntset: unrecognized option ',c
         stop
      endif

      return
      end




