**********************************************************************
*** function called in dspbbeuparm
*** it is integrated in the cylindrical coordinate z from 0 to
*** pbhg/pbhh (linear change of variables such that z=1 => z=pbhh
*** (half height of the diffusion box)) - part associated with sinh
*** version valid in case of constant galactic wind in the z direction
*** 
*** author: piero ullio (piero@tapir.caltech.edu)
*** date: 00-07-13
**********************************************************************

      real*8 function dspbbeupargs(z)
      implicit none
      real*8 z,radius,val,r,kpc
      include 'dspbcom.h'
      include 'dspbprivate.h'
      include 'dshmcom.h'
      common /czint/r
      parameter(kpc=3.08567802d0)
      if(hclumpy.eq.1) then                     ! smooth halo
        radius=dsqrt(r**2*pbrh**2+z**2*pbhh**2)
        call dshmhaloprof(radius,val)
        val=val/rho0
        val=val**2
      elseif(hclumpy.eq.2) then                 ! clumpy halo
        radius=dsqrt(r**2*pbrh**2+z**2*pbhh**2)
        call dshmhaloprof(radius,val)
        val=val/rho0
      else
        write(*,*) 'dspbbeupargs called with wrong hclumpy=',hclumpy
        stop
      endif
      if(z.lt.0.d0.or.z.gt.pbhg/pbhh) then
        write(*,*) 'dspbbeupargs called with wrong z=',z
        stop
      else
        dspbbeupargs=dsinh(lambdag*pbhh*kpc*(pbhg/pbhh-z))
     &              /dcosh(lambdag*pbhg*kpc)*val*pbhh*kpc
      endif
      return
      end
