**********************************************************************
*** function called in dspbtd15beu
*** it is integrated in the cylindrical coordinate r from 0 to 1 
*** (linear change of variables such that r=1 corresponds to r=pbrh 
*** (radial extent of the diffusion box))
*** 
*** author: piero ullio (piero@tapir.caltech.edu)
*** date: 00-07-13
**********************************************************************

      real*8 function dspbbeuparm(r)
      implicit none
      include 'dspbcom.h'
      include 'dspbprivate.h'
      real*8 r,rr,rebigh,rebiggs,rebiggc,kpc,dbesj0
      real*8 abserr,alist,blist,elist,epsabs,epsrel,rlist
     & ,resultgs,resultgc,resulth
      integer ier,iord,last,limit,neval
      dimension alist(5000),blist(5000),elist(5000),iord(5000),
     & rlist(5000)
      parameter(kpc=3.08567802d0)
      external dspbbeuparh,dspbbeupargs,dspbbeupargc
      common /czint/rr
      rr=r
      epsabs=1.d-10     !numerical accuracy
      epsrel=1.d-10
      limit=5000
c  rebigh, rebiggs, rebiggc in 10^6 cm sec^-1
      rebigh=1.d-50
      rebiggs=1.d-50
      rebiggc=1.d-50
      if(lambdag*pbhg.lt.1.d3) then
        rebigh=1.d0/dcosh(lambdag*pbhg*kpc)
     &   /(dg*lambdag*dtanh(lambdag*pbhg*kpc)+dh*gamh
     &     +dh*lambdah/dtanh(lambdah*(pbhh-pbhg)*kpc))
        rebiggs=1.d0/(dg*lambdag*dtanh(lambdag*pbhg*kpc)+dh*gamh
     &     +dh*lambdah/dtanh(lambdah*(pbhh-pbhg)*kpc))
        rebiggs=rebiggs/dg/lambdag*(dh*gamh
     &     +dh*lambdah/dtanh(lambdah*(pbhh-pbhg)*kpc))
        rebiggc=1.d0/(dg*lambdag*dtanh(lambdag*pbhg*kpc)+dh*gamh
     &     +dh*lambdah/dtanh(lambdah*(pbhh-pbhg)*kpc))
      endif
      call dqagseb(dspbbeupargs,0.d0,pbhg/pbhh,epsabs,epsrel,limit,
     &  resultgs,abserr,neval,ier,alist,blist,rlist,elist,iord,last)
      call dqagseb(dspbbeupargc,0.d0,pbhg/pbhh,epsabs,epsrel,limit,
     &  resultgc,abserr,neval,ier,alist,blist,rlist,elist,iord,last)
      call dqagseb(dspbbeuparh,pbhg/pbhh,1.d0,epsabs,epsrel,limit,
     &  resulth,abserr,neval,ier,alist,blist,rlist,elist,iord,last)
      dspbbeuparm=(pbrh*kpc)**2*r*dbesj0(zero*r)
     &   *(resulth*rebigh+resultgs*rebiggs+resultgc*rebiggc)
      return
      end
