      subroutine dspbset(c)
c...set parameters for antiproton routines
c...  c - character string specifying choice to be made
c...author: paolo gondolo 1999-07-14
      implicit none
      include 'dshmcom.h'
      include 'dspbcom.h'
      include 'dspbprivate.h'
      character*(*) c
      integer first
      data first/0/
      save first


      if (first.eq.0) then
c     call routine to initialize zeros of bessel j0
        call dspbzerobessj0
      endif

c...chardonnet et al 1996
      if (c.eq.'cha96') then
         pbpropmodel=1
         pbr0=8.0d0
         pbnzero=30
         pbhg=0.1d0             !(half thickness of the disk in kpc)
         pbhh=3.d0              !(height of the diffusion box in kpc)
         pbrh=20.d0             !(radius of the diffusion box in kpc)
         pbrig0=3.d0            !(proton rigidity in diffusion constant gev)
         pbkg=0.d0              !(diffusion coeff in gas in 10^-27 cm^2/s)
         pbkh=6.d0              !(diffusion coeff in halo in 10^27 cm^2/s
         pbng=1.d0              !(density of hydrogen in the disk in cm^-3)
         pbnh=0.d0              !(density of hydrogen in the halo in cm^-3)
         pbcvel=0.d0            !(galactic wind velocity in km/s)

c...bottino et al 1998
      else if (c.eq.'bot98') then
         pbpropmodel=1
         pbr0=8.0d0
         pbnzero=30
         pbhg=0.1d0             !(half thickness of the disk in kpc)
         pbhh=3.d0              !(height of the diffusion box in kpc)
         pbrh=20.d0             !(radius of the diffusion box in kpc)
         pbrig0=1.d0            !(proton rigidity in diffusion constantgev)
         pbkg=0.d0              !(diffusion coeff in gas in 10^-27 cm^2/s)
         pbkh=6.d0              !(diffusion coeff in halo in 10^27 cm^2/s
         pbng=1.d0              !(density of hydrogen in the disk in cm^-3)
         pbnh=0.d0              !(density of hydrogen in the halo in cm^-3)
         pbcvel=0.d0            !(galactic wind velocity in km/s)

c...bergstrom et al 1999
      else if (c.eq.'beu99'.or.c.eq.'default') then
         pbpropmodel=2
         pbr0=8.5d0
         pbnzero=30
         pbrh=20.d0             !(radius of the diffusion box in kpc)
         pbhg=0.1d0             !(half thickness of the disk in kpc)
         pbhh=3.d0              !(height of the diffusion box in kpc)
         pbng=1.d0              !(density of hydrogen in the disk in cm^-3)
         pbnh=0.d0              !(density of hydrogen in the halo in cm^-3)
         pbrig0=3.d0            !(proton rigidity in diffusion constant gev)
         pbkg=6.d0              !(diffusion coeff in gas in 10^-27 cm^2/s)
         pbkh=6.d0              !(diffusion coeff in halo in 10^-27 cm^2/s)
         pbcvel=0.d0            !(galactic wind velocity in km/s)

c...invalid choice
      else
         write (*,*) 'dspbset: unrecognized option ',c
         stop
      endif

      return
      end





