      subroutine dsrdaddpt(wrate,pres,deltap,pmax)
c_______________________________________________________________________
c  add a point in rdrate table
c  input:
c    wrate - invariant annihilation rate (real, external)
c    pres - momentum of the point to add
c    deltap - scaling factor used in dsrdtab
c    pmax - maximum p used in dsrdtab
c  common:
c    'dsrdcom.h' - included common blocks
c  used by dsrdtab
c  author: joakim edsjo (edsjo@physto.se)
c=======================================================================
      implicit none
      include 'dsrdcom.h'
      real*8 wrate
      external wrate
      integer i,j
      real*8 pres,deltap,pmax
      logical pexist
c-----------------------------------------------------------------------
      if (pres.le.0.0d0) return
c...check if p already exists
      pexist=.false.
      do i=1,nr
        if (pp(i).eq.pres/deltap) pexist=.true.
      enddo
      if (pexist) return

      if (pres.gt.pmax) then
        if (rdprt.gt.0) write(*,*)
     &    'dsrdaddpt: pmax raised from ',pmax,' to ',pres
        pmax=pres
        if (nr+1.ge.nrmax) then
          write (rdluerr,*) 'error in dsrdtab: array capacity exceeded'
          write (rdluerr,*) '  for model ',rdtag
          rderr=ibset(rderr,0)
          return
        endif
        nr=nr+1
        pp(nr)=pres/deltap
        yy(nr)=log(wrate(pres))
        indx(nr)=nr
      else
        if (nr+1.ge.nrmax) then
          write (rdluerr,*) 'error in dsrdtab: array capacity exceeded'
          write (rdluerr,*) '  for model ',rdtag
          rderr=ibset(rderr,0)
          return
        endif
        nr=nr+1
        pp(nr)=pres/deltap
        yy(nr)=log(wrate(pres))
        do i=1,nr-2
          if (pp(indx(i)).lt.pp(nr).and.pp(indx(i+1)).gt.pp(nr)) then
            do j=nr-1,i+1,-1
              indx(j+1)=indx(j)
            enddo
            indx(i+1)=nr
          endif
        enddo
      endif

      return
      end


