      subroutine dshwidths
c_______________________________________________________________________
c  common:
c    'dssusy.h' - file with susy common blocks
c  needs chasct, neusct, sfesct, higsct, vertx.
c  note: decays into sfermions neglected.
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994,1995
c       mar-95 formulas from higgs hunters guide
c    10-nov-95 complex vertex constants
c  modified: joakim edsjo to store partial higgs decay width 98-05-02
c  bugs fixed 98-05-02:
c     h1,h3 -> zz (was a factor of 2 mz**2/mw**2 too high)
c     h3 -> f fbar (was a factor of 4 too high)
c     h -> h h (was a factor of 2 too high)
c=======================================================================
      implicit none
      include 'dssusy.h'
      real*8 mh2o2, mh1o2, mh3o2, partial, kf, mn(4), mi, mj, dsabsq,
     &  vvv(12),sqlam,mh
      integer f,i,j,g,k(12),k1,k2

10    format (1x,a2,' -> dsff(',i2,')  partial=',e8.2)
11    format (1x,a2,' -> ww      partial=',e8.2)
12    format (1x,a2,' -> zz      partial=',e8.2)
13    format (1x,a2,' -> n',i1,'n',i1,'    partial=',e8.2)
      do 14 i=1,4
        mn(i) = abs(mass(kn(i)))
   14 continue
      do i=1,4
        do j=1,15
          hdwidth(j,i)=0.0d0
        enddo
      enddo
      i=1
      do g=1,3
        k(i)=knu(g)
        k(i+1)=kl(g)
        k(i+2)=kqu(g)
        k(i+3)=kqd(g)
        i=i+4
      enddo

c      write(*,*)
c      write(*,*) 'model: ',idtag
c======================================================== h2 decay width
      mh2o2 = 0.5d0*mass(kh2)
      width(kh2) = 0.0d0
c----------------------------------------------------------- into f fbar
c      write(*,*) 'h2 decays widths'
      do 15 f=1,12
        vvv(f)=0.0d0
        if (mass(k(f)).lt.mh2o2.and.
     &      mass(k(f)).ne.0.0d0) then
          kf = sqrt(1.0d0-(2.0d0*mass(k(f))/mass(kh2))**2)
          partial = mass(kh2) *  ncolor(k(f)) * kf**3 *
     &     dsabsq(gr(kh2,k(f),k(f))) / (8.0d0*pi)
          width(kh2) = width(kh2) + partial
          vvv(f)=partial
c          write(*,*) pname(k(f)),pname(k(f)),partial
        endif
   15 continue
      hdwidth(1,2)=vvv(7)    ! c c-bar
      hdwidth(2,2)=vvv(12)   ! b b-bar
      hdwidth(3,2)=vvv(11)   ! t t-bar
      hdwidth(4,2)=vvv(10)   ! tau+ tau-
      hdwidth(15,2)=vvv(6)   ! mu+ mu-
c-------------------------------------------------------------- into w w
      if (mass(kw).lt.mh2o2) then
        kf = sqrt(0.25d0-(mass(kw)/mass(kh2))**2)
        partial = mass(kh2) * kf *
     &    (mass(kw)/mass(kh2))**2 * dsabsq(gr(kh2,kw,kw))/8.0d0/pi *
     &    ( 2.0d0 + (1.0d0-0.5d0*(mass(kh2)/mass(kw))**2)**2 )
        width(kh2) = width(kh2) + partial
        hdwidth(5,2)=partial
c        write(*,*) pname(kw),pname(kw),partial
      endif
c-------------------------------------------------------------- into z z
c... je corr. 98-05-02
      if (mass(kz).lt.mh2o2) then
        kf = sqrt(0.25d0-(mass(kz)/mass(kh2))**2)
        partial = mass(kh2) * kf *
     &    (mass(kz)/mass(kh2))**2 * dsabsq(gr(kh2,kz,kz))*
     &    (mass(kw)/mass(kz))**2  /16.0d0/pi *
     &    ( 2.0d0 + (1.0d0-0.5d0*(mass(kh2)/mass(kz))**2)**2 )
        width(kh2) = width(kh2) + partial
        hdwidth(6,2)=partial
c        write(*,*) pname(kz),pname(kz),partial
      endif
c------------------------------------------------------------ into ni nj
      do 16 i=1,4
        do 17 j=1,4
          if (mn(i)+mn(j).lt.mass(kh2)) then
            kf = 0.5d0 *
     &        sqrt(1.0d0-( (mn(i)+mn(j))/mass(kh2) )**2) *
     &        sqrt(1.0d0-( (mn(i)-mn(j))/mass(kh2) )**2)
            partial=kf/(4*pi*mass(kh2)) * dsabsq(gr(kh2,kn(i),kn(j))) *
     &        (mass(kh2)**2-(mass(kn(i))+mass(kn(j)))**2) ! corr march 95
            if (i.eq.j) partial = partial/2.0d0
            width(kh2) = width(kh2) + partial
c            write(*,*) pname(kn(i)),pname(kn(j)),partial
          endif
   17   continue
   16 continue
c------------------------------------------------------------ into ci cj
      do i=1,2
        do j=1,2
          mi = mass(kcha(i))
          mj = mass(kcha(j))
          if (abs(mi)+abs(mj).lt.mass(kh2)) then
            kf = 0.5d0 *
     &        sqrt(1.0d0-( (mi+mj)/mass(kh2) )**2) *
     &        sqrt(1.0d0-( (mi-mj)/mass(kh2) )**2)
            partial = kf/(8*pi*mass(kh2)) *
     &        ( (dsabsq(gl(kh2,kcha(i),kcha(j)))+
     &           dsabsq(gr(kh2,kcha(i),kcha(j)))) *
     &             (mass(kh2)**2-mi**2-mj**2) -
     &          4.0d0*dreal(conjg(gl(kh2,kcha(i),kcha(j)))*
     &                 gr(kh2,kcha(i),kcha(j)))*mi*mj )
            width(kh2) = width(kh2) + partial
c            write(*,*) pname(kcha(i)),pname(kcha(j)),partial
          endif
        enddo
      enddo
c--------------------------------------------------------------into z h3
      if (mass(kz)+mass(kh3).lt.mass(kh2)) then
        kf = 0.5d0 * sqrt(1.0d0-((mass(kz)+mass(kh3))/mass(kh2))**2) *
     &          sqrt(1.0d0-((mass(kz)-mass(kh3))/mass(kh2))**2)
        partial = mass(kh2) * (mass(kh2)/mass(kz))**2 * kf**3 *
     &   dsabsq(gr(kz,kh3,kh2)) / (2.0d0*pi)
        hdwidth(13,2)=partial
        width(kh2) = width(kh2) + partial
c        write(*,*) pname(kz),pname(kh3),partial
      endif
c-------------------------------------------------------------- into w h
      if (mass(kw)+mass(khc).lt.mass(kh2)) then
        kf = 0.5d0 * sqrt(1.0d0-((mass(kw)+mass(khc))/mass(kh2))**2) *
     &          sqrt(1.0d0-((mass(kw)-mass(khc))/mass(kh2))**2)
        partial = mass(kh2) * (mass(kh2)/mass(kw))**2 * kf**3 *
     &   dsabsq(gr(kw,khc,kh2)) / (2.0d0*pi)
        hdwidth(14,2)=partial
        width(kh2) = width(kh2) + partial
c        write(*,*) pname(kw),pname(khc),partial
      endif
c------------------------------------------------------------ into h1 h1
      if (mass(kh1).lt.mh2o2) then
         kf = sqrt(0.25d0-(mass(kh1)/mass(kh2))**2)
         partial = (mass(kw)**2/mass(kh2)) * kf *
     &        dsabsq(gr(kh2,kh1,kh1)) / (16.d0*pi) ! je corr 98-05-02
         width(kh2) = width(kh2) + partial
         hdwidth(7,2)=partial
c         write(*,*) pname(kh1),pname(kh1),partial
      endif
c------------------------------------------------------------ into h3 h3
      if (mass(kh3).lt.mh2o2) then
         kf = sqrt(0.25d0-(mass(kh3)/mass(kh2))**2)
         partial = (mass(kw)**2/mass(kh2)) * kf *
     &        dsabsq(gr(kh2,kh3,kh3)) / (16.d0*pi) ! je corr 98-05-02
         width(kh2) = width(kh2) + partial
         hdwidth(9,2)=partial
c         write(*,*) pname(kh3),pname(kh3),partial
      endif
c-------------------------------------------------------------- into h h
      if (mass(khc).lt.mh2o2) then
         kf = sqrt(0.25d0-(mass(khc)/mass(kh2))**2)
         partial = (mass(kw)**2/mass(kh2)) * kf *
     &        dsabsq(gr(kh2,khc,khc)) / (16.d0*pi) ! je corr 98-05-02
         width(kh2) = width(kh2) + partial
         hdwidth(10,2)=0.0d0
c         write(*,*) pname(khc),pname(khc),partial
      endif
c======================================================== h1 decay width
c      write(*,*) 'h1 decay widths'
      mh1o2 = 0.5d0*mass(kh1)
      width(kh1) = 0.0d0
c----------------------------------------------------------- into f fbar
      do 18 f=1,12
        vvv(f)=0.0d0
        if (mass(k(f)).lt.mh1o2.and.
     &      mass(k(f)).ne.0.0d0) then
          kf = sqrt(1.0d0-(2.0d0*mass(k(f))/mass(kh1))**2)
          partial = mass(kh1) *  ncolor(k(f)) * kf**3 *
     &     dsabsq(gr(kh1,k(f),k(f))) / (8.0d0*pi)
          width(kh1) = width(kh1) + partial
          vvv(f)=partial
c          write(*,*) pname(k(f)),pname(k(f)),partial
        endif
   18 continue
      hdwidth(1,1)=vvv(7)    ! c c-bar
      hdwidth(2,1)=vvv(12)   ! b b-bar
      hdwidth(3,1)=vvv(11)   ! t t-bar
      hdwidth(4,1)=vvv(10)   ! tau+ tau-
      hdwidth(15,1)=vvv(6)   ! mu+ mu-
c-------------------------------------------------------------- into w w
      if (mass(kw).lt.mh1o2) then
        kf = sqrt(0.25d0-(mass(kw)/mass(kh1))**2)
        partial = mass(kh1) * kf *
     &    (mass(kw)/mass(kh1))**2 * dsabsq(gr(kh1,kw,kw))/8.0d0/pi *
     &    ( 2.0d0 + (1.0d0-0.5d0*(mass(kh1)/mass(kw))**2)**2 )
        width(kh1) = width(kh1) + partial
        hdwidth(5,1)=partial
c        write(*,*) pname(kw),pname(kw),partial
      endif
c-------------------------------------------------------------- into z z
c... je corr. 98-05-02
      if (mass(kz).lt.mh1o2) then
        kf = sqrt(0.25d0-(mass(kz)/mass(kh1))**2)
        partial = mass(kh1) * kf *
     &    (mass(kz)/mass(kh1))**2 * dsabsq(gr(kh1,kz,kz))*
     &    (mass(kw)/mass(kz))**2 /16.0d0/pi *
     &    ( 2.0d0 + (1.0d0-0.5d0*(mass(kh1)/mass(kz))**2)**2 )
        width(kh1) = width(kh1) + partial
        hdwidth(6,1)=partial
c        write(*,*) pname(kz),pname(kz),partial
      endif
c------------------------------------------------------------ into ni nj
      do 19 i=1,4
        do 20 j=1,4
          if (mn(i)+mn(j).lt.mass(kh1)) then
            kf = 0.5d0 *
     &        sqrt(1.0d0-( (mn(i)+mn(j))/mass(kh1) )**2) *
     &        sqrt(1.0d0-( (mn(i)-mn(j))/mass(kh1) )**2)
            partial=kf/(4*pi*mass(kh1)) * dsabsq(gr(kh1,kn(i),kn(j))) *
     &        (mass(kh1)**2-(mass(kn(i))+mass(kn(j)))**2) ! corr march 95
            if (i.eq.j) partial = partial/2.0d0
            width(kh1) = width(kh1) + partial
c            write(*,*) pname(kn(i)),pname(kn(j)),partial
          endif
   20   continue
   19 continue
c------------------------------------------------------------ into ci cj
      do i=1,2
        do j=1,2
          mi = mass(kcha(i))
          mj = mass(kcha(j))
          if (abs(mi)+abs(mj).lt.mass(kh1)) then
            kf = 0.5d0 *
     &        sqrt(1.0d0-( (mi+mj)/mass(kh1) )**2) *
     &        sqrt(1.0d0-( (mi-mj)/mass(kh1) )**2)
            partial = kf/(8*pi*mass(kh1)) *
     &        ( (dsabsq(gl(kh1,kcha(i),kcha(j)))+
     &           dsabsq(gr(kh1,kcha(i),kcha(j)))) *
     &             (mass(kh1)**2-mi**2-mj**2) -
     &          4.0d0*dreal(conjg(gl(kh2,kcha(i),kcha(j)))*
     &                 gr(kh2,kcha(i),kcha(j)))*mi*mj )
            width(kh1) = width(kh1) + partial
c            write(*,*) pname(kcha(i)),pname(kcha(j)),partial
          endif
        enddo
      enddo
c------------------------------------------------------------- into z h3
      if (mass(kz)+mass(kh3).lt.mass(kh1)) then
        kf = 0.5d0 * sqrt(1.0d0-((mass(kz)+mass(kh3))/mass(kh1))**2) *
     &          sqrt(1.0d0-((mass(kz)-mass(kh3))/mass(kh1))**2)
        partial = mass(kh1) * (mass(kh1)/mass(kz))**2 * kf**3 *
     &   dsabsq(gr(kz,kh3,kh1)) / (2.0d0*pi)
        width(kh1) = width(kh1) + partial
        hdwidth(13,1)=partial
c        write(*,*) pname(kz),pname(kh3),partial
      endif
c-------------------------------------------------------------- into w h
      if (mass(kw)+mass(khc).lt.mass(kh1)) then
        kf = 0.5d0 * sqrt(1.0d0-((mass(kw)+mass(khc))/mass(kh1))**2) *
     &          sqrt(1.0d0-((mass(kw)-mass(khc))/mass(kh1))**2)
        partial = mass(kh1) * (mass(kh1)/mass(kw))**2 * kf**3 *
     &   dsabsq(gr(kw,khc,kh1)) / (2.0d0*pi)
        width(kh1) = width(kh1) + partial
        hdwidth(14,1)=partial
c        write(*,*) pname(kw),pname(khc),partial
      endif
c------------------------------------------------------------ into h2 h2
      if (mass(kh2).lt.mh1o2) then
         kf = sqrt(0.25d0-(mass(kh2)/mass(kh1))**2)
         partial = (mass(kw)**2/mass(kh1)) * kf *
     &        dsabsq(gr(kh1,kh2,kh2)) / (16.d0*pi) ! je corr 98-05-02
         width(kh1) = width(kh1) + partial
         hdwidth(8,1)=partial
c         write(*,*) pname(kh2),pname(kh2),partial
      endif
c------------------------------------------------------------ into h3 h3
      if (mass(kh3).lt.mh1o2) then
         kf = sqrt(0.25d0-(mass(kh3)/mass(kh1))**2)
         partial = (mass(kw)**2/mass(kh1)) * kf *
     &        dsabsq(gr(kh1,kh3,kh3)) / (16.d0*pi) ! je corr 98-05-02
         width(kh1) = width(kh1) + partial
         hdwidth(9,1)=partial
c         write(*,*) pname(kh3),pname(kh3),partial
      endif
c-------------------------------------------------------------- into h h
      if (mass(khc).lt.mh1o2) then
         kf = sqrt(0.25d0-(mass(khc)/mass(kh1))**2)
         partial = (mass(kw)**2/mass(kh1)) * kf *
     &        dsabsq(gr(kh1,khc,khc)) / (16.d0*pi) ! je corr 98-05-02
         width(kh1) = width(kh1) + partial
         hdwidth(10,1)=partial
c         write(*,*) pname(khc),pname(khc),partial
      endif

c======================================================== h3 decay width
c      write(*,*) 'h3 decay widths'
      mh3o2 = 0.5d0*mass(kh3)
      width(kh3) = 0.0d0
c----------------------------------------------------------- into f fbar
      do 21 f=1,12
        vvv(f)=0.0d0
        if (mass(k(f)).lt.mh3o2.and.
     &      mass(k(f)).ne.0.0d0) then
          kf = sqrt(1.0d0-(2.0d0*mass(k(f))/mass(kh3))**2)
          partial = mass(kh3) *  ncolor(k(f)) * kf *
     &      dsabsq(gr(kh3,k(f),k(f))) / (8.0d0*pi)  ! je corr. 98-05-02
          width(kh3) = width(kh3) + partial
          vvv(f)=partial
c          write(*,*) pname(k(f)),pname(k(f)),partial
        endif
   21 continue
      hdwidth(1,3)=vvv(7)
      hdwidth(2,3)=vvv(12)
      hdwidth(3,3)=vvv(11)
      hdwidth(4,3)=vvv(10)
      hdwidth(15,3)=vvv(6)   ! mu+ mu-
c------------------------------------------------------------ into ni nj
      do 22 i=1,4
        do 23 j=1,4
          if (mn(i)+mn(j).lt.mass(kh3)) then
            kf = 0.5d0 *
     &       sqrt(1.0d0-( (mn(i)+mn(j))/mass(kh3) )**2) *
     &       sqrt(1.0d0-( (mn(i)-mn(j))/mass(kh3) )**2)
            partial=kf/(4*pi*mass(kh3)) * dsabsq(gr(kh3,kn(i),kn(j))) *
     &        (mass(kh3)**2-(mass(kn(i))-mass(kn(j)))**2)
            if (i.eq.j) partial = partial/2.0d0
            width(kh3) = width(kh3) + partial
c            write(*,*) pname(kn(i)),pname(kn(j)),partial
          endif
   23   continue
   22 continue
c------------------------------------------------------------ into ci cj
      do i=1,2
        do j=1,2
          mi = mass(kcha(i))
          mj = mass(kcha(j))
          if (abs(mi)+abs(mj).lt.mass(kh3)) then
            kf = 0.5d0 *
     &        sqrt(1.0d0-( (mi+mj)/mass(kh3) )**2) *
     &        sqrt(1.0d0-( (mi-mj)/mass(kh3) )**2)
            partial = kf/(8*pi*mass(kh3)) *
     &        ( (dsabsq(gl(kh3,kcha(i),kcha(j)))+
     &           dsabsq(gr(kh3,kcha(i),kcha(j)))) *
     &             (mass(kh3)**2-mi**2-mj**2) +
     &          4.0d0*dreal(gr(kh3,kcha(i),kcha(j))*
     &           conjg(gl(kh3,kcha(i),kcha(j))))*mi*mj )
            width(kh3) = width(kh3) + partial
c            write(*,*) pname(kcha(i)),pname(kcha(j)),partial
          endif
        enddo
      enddo
c------------------------------------------------------------- into z h1
      if (mass(kz)+mass(kh1).lt.mass(kh3)) then
        kf = 0.5d0 * sqrt(1.0d0-((mass(kz)+mass(kh1))/mass(kh3))**2) *
     &          sqrt(1.0d0-((mass(kz)-mass(kh1))/mass(kh3))**2)
        partial = mass(kh3) * (mass(kh3)/mass(kz))**2 * kf**3 *
     &   dsabsq(gr(kz,kh3,kh1)) / (2.0d0*pi)
        width(kh3) = width(kh3) + partial
        hdwidth(11,3)=partial
c        write(*,*) pname(kz),pname(kh1),partial
      endif
c------------------------------------------------------------- into z h2
      if (mass(kz)+mass(kh2).lt.mass(kh3)) then
        kf = 0.5d0 * sqrt(1.0d0-((mass(kz)+mass(kh2))/mass(kh3))**2) *
     &          sqrt(1.0d0-((mass(kz)-mass(kh2))/mass(kh3))**2)
        partial = mass(kh3) * (mass(kh3)/mass(kz))**2 * kf**3 *
     &   dsabsq(gr(kz,kh3,kh2)) / (2.0d0*pi)
        width(kh3) = width(kh3) + partial
        hdwidth(12,3)=partial
c        write(*,*) pname(kz),pname(kh2),partial
      endif
c-------------------------------------------------------------- into w h
      if (mass(kw)+mass(khc).lt.mass(kh3)) then
        kf = 0.5d0 * sqrt(1.0d0-((mass(kw)+mass(khc))/mass(kh3))**2) *
     &          sqrt(1.0d0-((mass(kw)-mass(khc))/mass(kh3))**2)
        partial = mass(kh3) * (mass(kh3)/mass(kw))**2 * kf**3 *
     &   dsabsq(gr(kw,khc,kh3)) / (2.0d0*pi)
        width(kh3) = width(kh3) + partial
        hdwidth(14,3)=partial
c        write(*,*) pname(kw),pname(khc),partial
      endif

c======================================================== h+ decay width
c... added by joakim edsjo, 98-05-02.
c... formulas from the higgs hunters guide, appendix b
c      write(*,*) 'h+ decay widths'
      width(khc)=0.0d0
      mh=mass(kh3)
c----------------------------------------------------------- into quarks
      do i=1,3
        do j=1,3
          vvv((i-1)*3+j)=0.0d0
          k1=kqu(i)
          k2=kqd(j)
          mi=mass(k1)
          mj=mass(k2)
          if ((mi+mj).lt.mh) then
            sqlam=sqrt((mi**2+mj**2-mh**2)**2-4*mi**2*mj**2)
            partial=3.0d0*sqlam/(16.0d0*pi*mh**3)*
     &        ((mh**2-mi**2-mj**2)*
     &        (dsabsq(gr(khc,k2,k1))+dsabsq(gl(khc,k2,k1)))-
     &        4*mi*mj*gl(khc,k2,k1)*gr(khc,k2,k1))
            width(khc)=width(khc)+partial
            vvv((i-1)*3+j)=partial
c            write(*,*) pname(k1),pname(k2),partial
          endif
        enddo
      enddo
      do i=1,9
        hdwidth(i,4)=vvv(i)
      enddo

c---------------------------------------------------------- into leptons
      do i=1,3
        vvv(i)=0.0d0
        k1=knu(i)
        k2=kl(i)
        mi=mass(k1)
        mj=mass(k2)
        if ((mi+mj).lt.mh) then
          sqlam=sqrt((mi**2+mj**2-mh**2)**2-4*mi**2*mj**2)
          partial=sqlam/(16.0d0*pi*mh**3)*
     &      ((mh**2-mi**2-mj**2)*
     &      (dsabsq(gr(khc,k2,k1))+dsabsq(gl(khc,k2,k1)))-
     &      4.0d0*mi*mj*gl(khc,k2,k1)*gr(khc,k2,k1))
          width(khc)=width(khc)+partial
          vvv(i)=partial
c          write(*,*) pname(k1),pname(k2),partial
        endif
      enddo
      do i=1,3
        hdwidth(i+9,4)=vvv(i)
      enddo

c------------------------------------------------------------ into w+ h1
      k1=kw
      k2=kh1
      mi=mass(k1)
      mj=mass(k2)
      if ((mi+mj).lt.mh) then
        sqlam=sqrt((mi**2+mj**2-mh**2)**2-4*mi**2*mj**2)
        partial=sqlam**3*dsabsq(gl(kw,khc,kh1))/
     &    (16.0d0*pi*mass(kw)**2*mh**3)
        width(khc)=width(khc)+partial
c        write(*,*) pname(k1),pname(k2),partial
        hdwidth(13,4)=partial
      endif

c------------------------------------------------------------ into w+ h2
      k1=kw
      k2=kh2
      mi=mass(k1)
      mj=mass(k2)
      if ((mi+mj).lt.mh) then
        sqlam=sqrt((mi**2+mj**2-mh**2)**2-4*mi**2*mj**2)
        partial=sqlam**3*dsabsq(gl(kw,khc,kh2))/
     &    (16.0d0*pi*mass(kw)**2*mh**3)
        width(khc)=width(khc)+partial
c        write(*,*) pname(k1),pname(k2),partial
        hdwidth(14,4)=partial
      endif

c------------------------------------------------------------ into w+ h3
      k1=kw
      k2=kh3
      mi=mass(k1)
      mj=mass(k2)
      if ((mi+mj).lt.mh) then
        sqlam=sqrt((mi**2+mj**2-mh**2)**2-4*mi**2*mj**2)
        partial=sqlam**3*dsabsq(gl(kw,khc,kh3))/
     &    (16.0d0*pi*mass(kw)**2*mh**3)
        width(khc)=width(khc)+partial
c        write(*,*) pname(k1),pname(k2),partial
        hdwidth(15,4)=partial
      endif

c---------------------------------------- into charginos and neutralinos
      do i=1,2
        do j=1,4
          k1=kcha(i)
          k2=kn(j)
          mi=mass(k1)
          mj=mass(k2)
          if ((mi+mj).lt.mh) then
            sqlam=sqrt((mi**2+mj**2-mh**2)**2-4*mi**2*mj**2)
            partial=sqlam/(16.0d0*pi*mh**3)*
     &        ((mh**2-mi**2-mj**2)*
     &        (dsabsq(gl(khc,k2,k1))+dsabsq(gr(khc,k2,k1)))-
     &        4.0d0*mi*mj*gl(khc,k2,k1)*gr(khc,k2,k1))
            width(khc)=width(khc)+partial
c            write(*,*) pname(k1),pname(k2),partial
          endif
        enddo
      enddo

c=============================================== decay widths calculated

      if (prtlevel.eq.-1) then
        write(*,*) 'suhwidths:'
        write(*,*) '  mh(1) = ',mass(kh1),'  width(kh1) = ',width(kh1)
        write(*,*) '  mh(2) = ',mass(kh2),'  width(kh2) = ',width(kh2)
        write(*,*) '  mh(3) = ',mass(kh3),'  width(kh3) = ',width(kh3)
        write(*,*) '    mhc = ',mass(khc),'  width(khc) = ',width(khc)

        do i=1,4
          do j=1,15
            write(*,*) 'hw: i=',i,' j=',j,': ',hdwidth(j,i)
          enddo
        enddo

      endif


      end
