      subroutine dsneusct
c_______________________________________________________________________
c  neutralino masses and mixings. base is b-ino, w3-ino, h1-ino, h2-ino.
c  common:
c    'dssusy.h' - file with susy common blocks
c  uses quartic.
c  called by susyin or mrkin.
c  author: paolo gondolo (gondolo@lpthe.jussieu.fr) 1994,1995
c  history:
c     940528 readability improvement (pg)
c     950316 order by increasing mass (pg)
c     951110 positive mass convention (pg)
c     970211 loop corrections via switch neuloop (joakim edsjo)
c     990724 drop v1,v2 and change mass scale to max(mz,m1,m2,mu) (pg)
c=======================================================================
      implicit none
      include 'dssusy.h'
      real*8 mx(4),a3,a2,a1,a0,x,w,mm,m1m,m2m,mum,mzm,m(4,4),a(4)
      real*8 s1
      real*8 neuzmx(4,4),delta_33,delta_44,qscale,hb,ht,sin2thb,sin2tht
      complex*16 dsb0loop
      integer i, j, k(4), tmpk
      external dsb0loop

c-----------------------------------------------------------------------
      mm = max(mass(kz),abs(m1),abs(m2),abs(mu))
      m1m = m1/mm
      m2m = m2/mm
      mum = mu/mm
      mzm = mass(kz)/mm
c mass matrix
      m(1,1)=m1m
      m(1,2)=0.0d0
      m(1,3)=-mzm*sinthw*cosbe
      m(1,4)=+mzm*sinthw*sinbe
      m(2,1)=m(1,2)
      m(2,2)=m2m
      m(2,3)=+mzm*costhw*cosbe
      m(2,4)=-mzm*costhw*sinbe
      m(3,1)=m(1,3)
      m(3,2)=m(2,3)
      m(3,3)=0.d0
      m(3,4)=-mum
      m(4,1)=m(1,4)
      m(4,2)=m(2,4)
      m(4,3)=m(3,4)
      m(4,4)=0.d0

c...drees, nojiri, roy and yamada loop corrections, astro-ph/9701219
c...je addition 97-02-11
      delta_33=0.d0
      delta_44=0.d0
      if (neuloop.ge.1) then
        qscale = abs(mu)
        hb=g2weak*mass(kb)/(sqrt(2.0d0)*mass(kw)*cosbe)
        ht=g2weak*mass(kt)/(sqrt(2.0d0)*mass(kw)*sinbe)
        sin2thb = -2.0d0*dreal(sqdlmx(3,3)*sqdlmx(6,3))
        sin2tht = -2.0d0*dreal(squlmx(3,3)*squlmx(6,3))
        delta_33 = -3.0d0/(16.0d0*pi**2)*hb**2*mass(kb)*sin2thb*
     &    dreal(dsb0loop(qscale,mass(kb),mass(ksqd(3)))-
     &    dsb0loop(qscale,mass(kb),mass(ksqd(6))))
        delta_44 = -3.0d0/(16.0d0*pi**2)*ht**2*mass(kt)*sin2tht*
     &    dreal(dsb0loop(qscale,mass(kt),mass(ksqu(3)))-
     &    dsb0loop(qscale,mass(kt),mass(ksqu(6))))
        m(3,3) = delta_33/mm
        m(4,4) = delta_44/mm
      endif

      if (prtlevel.ge.2) then
         write (*, '('' neutralino mass matrix ='',4(f10.2))')
     &        (mm*m(1,i),i=1,4)
         do j=2,4
            write (*, '(''                         '',4(f10.2))')
     &           (mm*m(j,i),i=1,4)
         enddo
      endif

c...paolos old expressions before the drees et al addition
c      a3 = -m1m-m2m
c      a2 = m1m*m2m-mum**2-m(1,3)**2-m(1,4)**2-m(2,3)**2-m(2,4)**2
c      a1 = mum**2*(m1m+m2m)+
c     & m1m*(m(2,4)**2+m(2,3)**2)+
c     & m2m*(m(1,3)**2+m(1,4)**2)+
c     & 2*mum*(m(1,3)*m(1,4)+m(2,3)*m(2,4))
c      a0 = -mum**2*m1m*m2m-
c     & 2*mum*(m2m*m(1,3)*m(1,4)+m1m*m(2,3)*m(2,4))+
c     & (m(1,4)*m(2,3)-m(1,3)*m(2,4))**2
c...maple generated output for the polynomial coefficient, je 97-02-12
      a3 = -m(1,1)-m(2,2)-m(3,3)-m(4,4)
      a2 = -m(4,1)*m(1,4)-m(2,1)*m(1,2)+m(2,2)*m(3,3)+m(2,2)*m(4,4)+m(3,
     #3)*m(4,4)-m(3,4)*m(4,3)-m(3,2)*m(2,3)-m(4,2)*m(2,4)+m(1,1)*m(2,2)+
     #m(1,1)*m(3,3)+m(1,1)*m(4,4)-m(3,1)*m(1,3)
      a1 = -m(1,1)*m(2,2)*m(3,3)-m(1,1)*m(2,2)*m(4,4)-m(1,1)*m(3,3)*m(4,
     #4)+m(1,1)*m(3,4)*m(4,3)+m(1,1)*m(3,2)*m(2,3)+m(1,1)*m(4,2)*m(2,4)-
     #m(2,2)*m(3,3)*m(4,4)+m(2,2)*m(3,4)*m(4,3)+m(3,2)*m(2,3)*m(4,4)-m(3
     #,2)*m(2,4)*m(4,3)-m(4,2)*m(2,3)*m(3,4)+m(4,2)*m(2,4)*m(3,3)+m(2,1)
     #*m(1,2)*m(3,3)+m(2,1)*m(1,2)*m(4,4)-m(2,1)*m(3,2)*m(1,3)-m(2,1)*m(
     #4,2)*m(1,4)-m(3,1)*m(1,2)*m(2,3)+m(3,1)*m(2,2)*m(1,3)+m(3,1)*m(1,3
     #)*m(4,4)-m(3,1)*m(1,4)*m(4,3)-m(4,1)*m(1,2)*m(2,4)+m(4,1)*m(2,2)*m
     #(1,4)-m(4,1)*m(1,3)*m(3,4)+m(4,1)*m(1,4)*m(3,3)
      s1 = m(1,1)*m(2,2)*m(3,3)*m(4,4)-m(1,1)*m(2,2)*m(3,4)*m(4,3)-m(1,1
     #)*m(3,2)*m(2,3)*m(4,4)+m(1,1)*m(3,2)*m(2,4)*m(4,3)+m(1,1)*m(4,2)*m
     #(2,3)*m(3,4)-m(1,1)*m(4,2)*m(2,4)*m(3,3)-m(2,1)*m(1,2)*m(3,3)*m(4,
     #4)+m(2,1)*m(1,2)*m(3,4)*m(4,3)+m(2,1)*m(3,2)*m(1,3)*m(4,4)-m(2,1)*
     #m(3,2)*m(1,4)*m(4,3)-m(2,1)*m(4,2)*m(1,3)*m(3,4)+m(2,1)*m(4,2)*m(1
     #,4)*m(3,3)
      a0 = s1+m(3,1)*m(1,2)*m(2,3)*m(4,4)-m(3,1)*m(1,2)*m(2,4)*m(4,3)-m(
     #3,1)*m(2,2)*m(1,3)*m(4,4)+m(3,1)*m(2,2)*m(1,4)*m(4,3)+m(3,1)*m(4,2
     #)*m(1,3)*m(2,4)-m(3,1)*m(4,2)*m(1,4)*m(2,3)-m(4,1)*m(1,2)*m(2,3)*m
     #(3,4)+m(4,1)*m(1,2)*m(2,4)*m(3,3)+m(4,1)*m(2,2)*m(1,3)*m(3,4)-m(4,
     #1)*m(2,2)*m(1,4)*m(3,3)-m(4,1)*m(3,2)*m(1,3)*m(2,4)+m(4,1)*m(3,2)*
     #m(1,4)*m(2,3)

c eigenvalues
      call dsquartic(a3,a2,a1,a0,mx(4),mx(2),mx(3),mx(1))
c order by increasing mass
      do i=1,4
         k(i) = i
      enddo
      do j=2,4
         tmpk=k(j)
         do i=j-1,1,-1
            if(abs(mx(k(i))).le.abs(mx(tmpk))) goto 100
            k(i+1)=k(i)
         enddo
         i=0
 100     k(i+1)=tmpk
      enddo
      do i=1,4
         a(i)=mx(i)
      enddo
      do i=1,4
         mx(i)=a(k(i))
      enddo
      kln=1
c eigenvectors
      do 120 i=1,4
        mass(kn(i)) = mm*abs(mx(i))
        m(1,1)=m1m-mx(i)
        m(2,2)=m2m-mx(i)
c...je addition 97-02-12
        if (neuloop.ge.1) then
          m(3,3)=delta_33/mm-mx(i)
          m(4,4)=delta_44/mm-mx(i)
        else
          m(3,3)=-mx(i)
          m(4,4)=-mx(i)
        endif
        w=+m(1,1)*m(2,2)*m(3,3)+m(1,2)*m(2,3)*m(3,1)
     &    +m(1,3)*m(2,1)*m(3,2)-m(1,1)*m(2,3)*m(3,2)
     &    -m(1,2)*m(2,1)*m(3,3)-m(1,3)*m(2,2)*m(3,1)
        neuzmx(i,1)=-(+m(1,4)*m(2,2)*m(3,3)+m(1,2)*m(2,3)*m(3,4)
     &                 +m(1,3)*m(2,4)*m(3,2)-m(1,4)*m(2,3)*m(3,2)
     &                 -m(1,2)*m(2,4)*m(3,3)-m(1,3)*m(2,2)*m(3,4))/w
        neuzmx(i,2)=-(+m(1,1)*m(2,4)*m(3,3)+m(1,4)*m(2,3)*m(3,1)
     &                 +m(1,3)*m(2,1)*m(3,4)-m(1,1)*m(2,3)*m(3,4)
     &                 -m(1,4)*m(2,1)*m(3,3)-m(1,3)*m(2,4)*m(3,1))/w
        neuzmx(i,3)=-(+m(1,1)*m(2,2)*m(3,4)+m(1,2)*m(2,4)*m(3,1)
     &                 +m(1,4)*m(2,1)*m(3,2)-m(1,1)*m(2,4)*m(3,2)
     &                 -m(1,2)*m(2,1)*m(3,4)-m(1,4)*m(2,2)*m(3,1))/w
        neuzmx(i,4)=1.0d0
        x = 1.0d0/sqrt(neuzmx(i,1)**2+neuzmx(i,2)**2+
     &                 neuzmx(i,3)**2+neuzmx(i,4)**2)
        do 110 j=1,4
          neuzmx(i,j) = neuzmx(i,j)*x
          if (mx(i).ge.0.d0) then
            neunmx(i,j) = cmplx(neuzmx(i,j),0.d0)
          else
            neunmx(i,j) = cmplx(0.d0,neuzmx(i,j))
          endif
  110   continue
  120 continue

      end
